<?php

if ( ! defined( 'ABSPATH' ) )
	exit;



class gootracking_WC_Order_Custom{
	protected $id;
	protected $comment;
	protected $serialNumber;
	protected $trackingId;
	protected $image;
	protected $IdPdfLabel;
	protected $IdPdfCustom;
	
	protected $parentOrder;
	protected $linkedOrder;
	protected $orderIdRetrunToFinalCust;
	
	protected $shippingType;
	protected $arrayHistoricalView;
	protected $arrayFeedback;
	protected $arrayHistoricalFeedbackRequest;



	
	
	
	
	
	
	
	public function __construct( $id = '' ) {
		if($id != null){		
			// parent::__construct( $id = '' );		
			
			$this->id = $id;
			$this->comment = get_post_meta( $id, '_'.'comment',true );
			$this->serialNumber = get_post_meta( $id, '_'.'serialNumber',true );
			$this->trackingId = get_post_meta( $id, '_'.'trackingId',true );
			$this->image = get_post_meta( $id, '_'.'image',true );
			$this->IdPdfLabel = get_post_meta( $id, '_'.'IdPdfLabel',true );
			$this->parentOrder = get_post_meta( $id, '_'.'parentOrder',true );
			$this->IdPdfCustom = get_post_meta( $id, '_'.'IdPdfCustom',true );
			$this->linkedOrder = get_post_meta( $id, '_'.'linkedOrder',true );
			$this->orderIdRetrunToFinalCust = get_post_meta( $id, '_'.'orderIdRetrunToFinalCust',true );			
			$this->shippingType = get_post_meta( $id, '_'.'shippingType',true );
			$this->arrayHistoricalView = get_post_meta( $id, '_'.'arrayHistoricalView',true );
			$this->arrayFeedback = get_post_meta( $id, '_'.'arrayFeedback',true );
			$this->arrayHistoricalFeedbackRequest = get_post_meta( $id, '_'.'arrayHistoricalFeedbackRequest',true );
			
		}		
	}
	

	
	
	function getid(){                   								return $this->id; }
	function getcomment(){                   							return $this->comment; }
	function getserialNumber(){                   						return $this->serialNumber; }	
	function gettrackingId(){                   						return $this->trackingId; }
	function getimage(){             		      						return $this->image; }
	function getIdPdfLabel(){             								return $this->IdPdfLabel; }
	function getparentOrder(){             		      					return $this->parentOrder; }
	function getIdPdfCustom(){             		      					return $this->IdPdfCustom; }
	function getlinkedOrder(){             		      					return $this->linkedOrder; }
	function getorderIdRetrunToFinalCust(){            					return $this->orderIdRetrunToFinalCust; }
	function getshippingType(){             		      				return $this->shippingType; }
	function getarrayHistoricalView(){             		   	   			return $this->arrayHistoricalView; }
	function getarrayFeedback(){             		   	   				return $this->arrayFeedback; }
	function getarrayHistoricalFeedbackRequest(){						return $this->arrayHistoricalFeedbackRequest; }
	
	function getshippingTypeFormated(){
		$order_id = $this->id;
		if($this->shippingType == 'UPS') {
			$oWC_Order_Custom = gootracking_WC_Order_Custom::getCorrectInstanceOf_WC_Order_Custom($order_id);
			if($oWC_Order_Custom->isPickupClient) {
				$isPickupClient = ' '.'PickupClient';
			} else {
				$isPickupClient = '';
			}
		}
		return $this->shippingType . $isPickupClient; 
	}
	
	
	
	function setid($id) {															$this->id = $id; }
	function setcomment($comment) {													$this->comment = $comment; }	
	function setserialNumber($serialNumber) {										$this->serialNumber = $serialNumber; }
	function settrackingId($trackingId) {											$this->trackingId = $trackingId; }
	function setimage($image) {														$this->image = $image; }
	function setIdPdfLabel($IdPdfLabel) {											$this->IdPdfLabel = $IdPdfLabel; }
	function setparentOrder($parentOrder) {											$this->parentOrder = $parentOrder; }
	function setIdPdfCustom($IdPdfCustom) {											$this->IdPdfCustom = $IdPdfCustom; }
	function setlinkedOrder($linkedOrder) {											$this->linkedOrder = $linkedOrder; }
	function setorderIdRetrunToFinalCust($orderIdRetrunToFinalCust) {				$this->orderIdRetrunToFinalCust = $orderIdRetrunToFinalCust; }
	function setshippingType($shippingType) {										$this->shippingType = $shippingType; }
	function setarrayHistoricalView($arrayHistoricalView) {							$this->arrayHistoricalView = $arrayHistoricalView; }
	function setarrayFeedback($arrayFeedback) {										$this->arrayFeedback = $arrayFeedback; }
	function setarrayHistoricalFeedbackRequest($arrayHistoricalFeedbackRequest) {	$this->arrayHistoricalFeedbackRequest = $arrayHistoricalFeedbackRequest; }
	
	
	

	
	function save(){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}
		

		$order_id = $this->id;
		update_post_meta($order_id, '_'.'comment', $this->comment );
		update_post_meta($order_id, '_'.'serialNumber', $this->serialNumber );		
		update_post_meta($order_id, '_'.'trackingId', $this->trackingId );
		update_post_meta($order_id, '_'.'image', $this->image );
		update_post_meta($order_id, '_'.'IdPdfLabel', $this->IdPdfLabel );
		update_post_meta($order_id, '_'.'parentOrder', $this->parentOrder );
		update_post_meta($order_id, '_'.'IdPdfCustom', $this->IdPdfCustom );
		update_post_meta($order_id, '_'.'linkedOrder', $this->linkedOrder );
		update_post_meta($order_id, '_'.'orderIdRetrunToFinalCust', $this->orderIdRetrunToFinalCust );
		update_post_meta($order_id, '_'.'shippingType', $this->shippingType );
		update_post_meta($order_id, '_'.'arrayHistoricalView', $this->arrayHistoricalView );
		update_post_meta($order_id, '_'.'arrayFeedback', $this->arrayFeedback );
		update_post_meta($order_id, '_'.'arrayHistoricalFeedbackRequest', $this->arrayHistoricalFeedbackRequest );






		return $order_id;	
	}

	
	function delete() {
		if($this->id != null){
			wp_delete_post($this->id,true);
		}		
	}

	
	function getImageProductUrl() {		
		return plugins_url( 'assets/'. $this->shippingType . ".png",  dirname(__FILE__) ) ;
	}
	
	public static function isSessionShippingType($shippingTypeToCompare, $oWC_Order_Custom = null ) {
		if($oWC_Order_Custom==null) {
			if(is_object(WC()->session)) {
				$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
			} else {
				return false;
			}
		}	
		if(is_object($oWC_Order_Custom)) {
			$shippingType = $oWC_Order_Custom->getshippingType();
			if($shippingType == $shippingTypeToCompare) {
				return true;
			}
		}
		
		return false;
	}

	function thisOrderGetLabels() {
		if(	$this->IdPdfLabel == '' && $this->IdPdfCustom == '') {
			return false;
		}
		return true;
	}
	
	public static function isPrudctAndSessionShippingType($shippingTypeToCompare, $oWC_Order_Custom = null ) {
		if (gootracking_WC_Order_Custom::isSessionShippingType($shippingTypeToCompare) == true) {
			if(get_the_ID()==get_option("gootracking_product_id_". $shippingTypeToCompare)) {
				return true;
			} else {
				/*
				$oWC_Order_Custom = new gootracking_WC_Order_Custom();	
				$oWC_Order_Custom->setshippingType("");		
				WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );	
*/				
			}
		}
		return false;
	}
	
	public static function getCorrectInstanceOf_WC_Order_Custom($order_id) {
		
		$oWC_Order_Custom = new gootracking_WC_Order_Custom($order_id);
		if($oWC_Order_Custom->getshippingType()=="Kiala") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_Kiala($order_id);
		} else if($oWC_Order_Custom->getshippingType()=="UPS") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_UPS($order_id);
		}
		return $oWC_Order_Custom ;
	}
	
	/*
	public function castAs($newClass) {
		$obj = new $newClass;
		foreach (get_object_vars($this) as $key => $name) {
			$obj->$key = $name;
		}
		return $obj;
	}	
	*/
	function translateShippingType() {
		$shippingType = $this->shippingType;
		switch ($shippingType) {
			case 'returnToFinalCust':
				return __('Return to Final customer', 'gootracking-for-woocommerce' );
				break;
			case 'quote':
				return __('Quote', 'gootracking-for-woocommerce' );
				break;				
			default:
				return $shippingType;
		}

		
	}



	function getarrayoWC_Order_Custom($isAfterPlacedOrder=false) {
		$arrayoWC_Order_Custom = array (
			//__('shippingType', 'gootracking') => $this->translateShippingType(),	
			__('shippingTypeFormated', 'gootracking') => $this->getshippingTypeFormated(),
			__('Comment', 'gootracking') => $this->comment,
			__('Serial Number', 'gootracking') => $this->serialNumber,
		);
		
		$order = new WC_Order($this->id);
		if($isAfterPlacedOrder == true ) {
			$arrayoWC_Order_Custom[__('order ID', 'gootracking')]= $this->id;
			$arrayoWC_Order_Custom[__('Name', 'gootracking')]= $order->billing_first_name . " " . $order->billing_last_name;
			$arrayoWC_Order_Custom[__('Customer note', 'gootracking')]= $order->customer_note ;
		}
		
		
		
			
		if($this->shippingType == "Kiala"){				
			$arrayoWC_Order_Custom[__('Kiala Name', 'gootracking')]= $this->kpname ." (". $this->shortkpid .")";
			$arrayoWC_Order_Custom[__('Kiala Address', 'gootracking')] =  $this->street . " - " . $this->city . " - " . $this->zip;
			$arrayoWC_Order_Custom[__('locationhint', 'gootracking')]=  $this->locationhint;
			$arrayoWC_Order_Custom[__('totalPhraseSchedule', 'gootracking')]=  $this->totalPhraseSchedule;			
		} else if($this->shippingType == "UPS"){
			if($isAfterPlacedOrder == true ) {
				if(get_option("gootracking_debug") == "true") {
					$IdPdfLabel = $this->getIdPdfLabel();
					$opdfUPS = new gootracking_pdfUPS($IdPdfLabel );
					$arrayoWC_Order_Custom[__('URLAPI', 'gootracking')] =  $opdfUPS->getURLAPIFormated();
				}
			}			
			if(get_option('gootracking_ask_UPS_dimensions_item') != "false") {
				
				$arrayoWC_Order_Custom[__('itemWeight', 'gootracking')]=  $this->itemWeight;
				/*$arrayoWC_Order_Custom[__('itemLength', 'gootracking')]=  $this->itemLength;
				$arrayoWC_Order_Custom[__('itemWidth', 'gootracking')]=  $this->itemWidth;
				$arrayoWC_Order_Custom[__('itemHeight', 'gootracking')]=  $this->itemHeight;*/
				
				$arrayoWC_Order_Custom[__('Item Size', 'gootracking')]=  $this->itemLength."x".$this->itemWidth."x".$this->itemHeight;
			}
		}
		
		/*
		if($showTrackingId==true) {
			$arrayoWC_Order_Custom['trackingId'] = $this->trackingId;
		}
		*/

		foreach($arrayoWC_Order_Custom as $key => $value) {
			if($value != '') {
				$arrayoWC_Order_Custom_without_empty_value[ $key ] =  $value ;
			}
		}

		$arrayoWC_Order_Custom = $arrayoWC_Order_Custom_without_empty_value;		
		return $arrayoWC_Order_Custom;
		
	}
	
	function incrementHistoricalFeedbackRequest($source) {
		$arrayHistoricalFeedbackRequest = $this->getarrayHistoricalFeedbackRequest();
		$user_id =  get_current_user_id();
	//	$user_info = get_userdata( $user_id );
	//	$user_login = $user_info->user_login;
		$date = date( 'Y-m-d H:i:s' );
		$arrayHistoricalFeedbackRequest[] = array(
			'user_id' 		=> $user_id,
			'is_admin' 		=> true,
			'date' 			=> $date,
			'source'		=> $source,
		);
		$this->setarrayHistoricalFeedbackRequest($arrayHistoricalFeedbackRequest);
		$this->save();
	}
	function incrementArrayHistoricalView( $is_admin = false ) {
		if(!isset($_GET['sourceTraffic'])) {
			$sourceTraffic = 'web';
		} else {
			$sourceTraffic = $_GET['sourceTraffic'];
		}
		$pageAction = $_GET['gootrackingAction'];
		$user_id =  get_current_user_id();
		$arrayHistoricalView = $this->getarrayHistoricalView();
		$date = date( 'Y-m-d H:i:s' );

		$arrayHistoricalView[] = array(
			'sourceTraffic' 	=> $sourceTraffic,
			'user_id' 			=> $user_id,
			'is_admin' 			=> $is_admin,
			'pageAction' 		=> $pageAction,
			'date' 				=> $date,
		);
		$this->setarrayHistoricalView($arrayHistoricalView);
		$this->save();
	}

	function resetArrayHistoricalView( $is_admin = true ) {
		
		// we must delete only order rows or user rows
		$array = $this->getarrayHistoricalView();
		if($array == null)
			return;	

	
		foreach( $array as $key=>$value){
			if($value['is_admin'] != $is_admin) {
				$newArray[$key] = $value ;
			}
		}
		$this->setarrayHistoricalView($newArray);
		$this->save();	
	}


	
    function showFormatedArrayHistoricalView( $is_admin ){		
		$array = $this->getarrayHistoricalView();
		$this->showFormatedArray($array, $is_admin);	
	}

	
    function showFormatedArrayFeedbacks(){		
		$array = $this->getarrayFeedback();
		$this->showFormatedArray($array, false);
	}

	function showFormatedArrayHistoricalFeedbackRequest() {
		$array = $this->getarrayHistoricalFeedbackRequest();
		$this->showFormatedArray($array);		
	}

	
    function showFormatedArray($array, $is_admin = true){	
    	if($array == null)
    		return;
		$html = '<table>';
		// header row
		$html .= '<tr>';
		foreach($array[0] as $key=>$value){
				if($key != 'is_admin' ) {
					$html .= '<th>' . $key . '</th>';
				}
			}
		$html .= '</tr>';

		foreach( $array as $key=>$value){
			if($value['is_admin'] == $is_admin) {
				$html .= '<tr>';
				foreach($value as $key2=>$value2){
					if($key2 != 'is_admin' ) {
						if($key2 == 'user_id' ) {
							

							$user_info = get_userdata( $value2 );
							$user_login = $user_info->user_login;
						//	$first_name = $user_info->first_name;
						//	$last_name = $user_info->last_name;

							$user_formated = $user_login."(<a href='".admin_url()."/user-edit.php?user_id=". $value2 ."'>" . $value2 ."</a>)";
							$value2 = $user_formated;


						}
						$html .= '<td>' . $value2 . '</td>';						
					}
				}
			}
			$html .= '</tr>';
		}
		$html .= '</table>';
		echo $html;
	}	
	function sendOrderStatusByEmail($typeEmail=null) {
		//https://docs.woothemes.com/wc-apidocs/class-WC_Email.html
		global $woocommerce;
		$order = new WC_Order($this->id);
		$order_status = $order->get_status();
		//completed
		//processing
		$mailer = $woocommerce->mailer();
		if($typeEmail==null) {
			$typeEmail = 'WC_Email_New_Order';
		}
		$email = $mailer->emails[$typeEmail];
		$email->trigger( $this->id);

	}

	function isFirstShippingOrder() {
		if($this->shippingType == 'returnToFinalCust' || $this->shippingType == 'quote' ) {
			return false;
		}
		return true;
	}
	function createNewOrder($shippingType){

		$order = new WC_Order($this->id);
		$variation_detail ="";
		$items = $order->get_items();

		foreach ( $items as $item ) {
			$_product = new WC_Product_Variation( $item['variation_id'] );
			if($_product->get_id()!="") {
				$variation_data = $_product->get_variation_attributes();
				$variation_detail = woocommerce_get_formatted_variation( $variation_data, true );
			}
		}
	//	$note = __('New order created from your previous order', 'gootracking')." (".$order_id. ") ".__('for', 'gootracking')." " . $variation_detail . "";
		
		$args = array(
			//'status'        => 'Pending Payment',
			'customer_id'   => $order->customer_user,
		//	'customer_note' => $note,			
		);			
		
		$order_new = wc_create_order($args);
		
		
		$billing_address = array(
			'first_name' => $order->billing_first_name,
			'last_name'  => $order->billing_last_name,
			'company'    => $order->billing_company,
			'email'      => $order->billing_email,
			'phone'      => $order->billing_phone,
			'address_1'  => $order->billing_address_1,
			'address_2'  => $order->billing_address_2,
			'city'       =>	$order->billing_city,
			'state'      => $order->billing_state,
			'postcode'   => $order->billing_postcode,
			'country'    => $order->billing_country,
		);
		$shipping_address = array(
			'first_name' => $order->shipping_first_name,
			'last_name'  => $order->shipping_last_name,
			'company'    => $order->shipping_company,
			'email'      => $order->shipping_email,
			'phone'      => $order->shipping_phone,
			'address_1'  => $order->shipping_address_1,
			'address_2'  => $order->shipping_address_2,
			'city'       =>	$order->shipping_city,
			'state'      => $order->shipping_state,
			'postcode'   => $order->shipping_postcode,
			'country'    => $order->shipping_country,
		);		
		
		$order_id_new = $order_new->id;

        $order_new->set_address( $billing_address, 'billing' );
        $order_new->set_address( $shipping_address, 'shipping' );
		if($shippingType == 'quote') {

			$product = wc_get_product(get_option('gootracking_product_id_Kiala'));
			$title=$product->get_title();
			
			if(isset($_POST['title'])){	
				$title .= " ".$_POST['title'];
			}
			if($variation_detail!="") {
				$title .= " (".$variation_detail.")";
			}
			//$order_new->add_product(9, 2);
			//do_action( 'woocommerce_order_add_product', $this->id, $item_id, $product, $qty, $args );
			
			//$array =  (array) $product;
			$product->post->post_title = $title;
			if(isset($_POST['price'])){	
				$product->set_price($_POST['price']);
			}

			
			// See with Fred. We do not add prodcut after an order is created.
			// We do not add a note
			// We do not calculate price
			
			//$order_new->add_product($product, 1);
			//$order_new->calculate_totals();		
			//$order_new->add_order_note($note, 1);
			
			$oWC_Order_Custom_new = new gootracking_WC_Order_Custom( $order_id_new );
			
			$this->setlinkedOrder($order_id_new);
			$oWC_Order_Custom_new->setshippingType('quote');
			//$oWC_Order_Custom_new->setlinkedOrder($order_id);
			$oWC_Order_Custom_new->setparentOrder($this->id);
			
			$this->save();
			$oWC_Order_Custom_new->save();
			//var_dump(get_edit_post_link($order_id_new ));
			//wp_mail( 'sternwebagency@gmail.com', '[alan]', $_POST['order_id']."alan".get_edit_post_link($order_id_new,"&"));
			return $order_id_new;
		} else if($shippingType == 'returnToFinalCust') {			
			$oWC_Order_Custom_new = new gootracking_WC_Order_Custom_UPS( $order_id_new );
			$oWC_Order_Custom_new->setunit_Code( 'CM' );
			$oWC_Order_Custom_new->setunitWeight( 'KGS' );
			$oWC_Order_Custom_new->setaddress_AddressLine( $order->billing_address_1 . " " . $order->billing_address_2 );
			$oWC_Order_Custom_new->setaddress_City( $order->billing_city);
			$oWC_Order_Custom_new->setaddress_PostalCode( $order->billing_postcode);
			$oWC_Order_Custom_new->setCompanyName( $order->billing_company);
			$oWC_Order_Custom_new->setContactName( $order->billing_first_name . " " . $order->billing_last_name);
			$oWC_Order_Custom_new->setaddress_CountryCode( get_option('gootracking_company_country') );
			$oWC_Order_Custom_new->setphone_Number( $order->billing_phone );	
			$oWC_Order_Custom_new->setparentOrder( $this->id );	
			$oWC_Order_Custom_new->setshippingType('returnToFinalCust');
			
			
			$this->setorderIdRetrunToFinalCust($order_id_new);
			$this->save();
			$oWC_Order_Custom_new->save();	
			
			$opdfUPS = new gootracking_pdfUPS();
			$opdfUPS->setorder_id($order_id_new);
			$opdfUPS->setURL("UPS.pdf");
			$opdfUPS->settypePDF("pdfUPS");
			$opdfUPS->setURLAPI(true);
			
			
			$opdfUPS->getRespUPS();		
			$opdfUPS->saveUPSLabelToServer();
			$IdPdfLabel = $opdfUPS->save();	
			$oWC_Order_Custom_new->setIdPdfLabel($IdPdfLabel);
			$oWC_Order_Custom_new->save();		
			//var_dump(get_edit_post_link($order_id_new ));
			//wp_redirect(get_edit_post_link($order_id_new ));
			return $order_id_new;		
		}
	}


}
	