<?php

if ( ! defined( 'ABSPATH' ) )
	exit;



class gootracking_WC_Order_Custom_Kiala extends gootracking_WC_Order_Custom {
	
	protected $isPickupClient;
	protected $kpname;
	protected $shortkpid;
	protected $street;
	protected $zip;
	protected $city;
	protected $locationhint;
	protected $totalPhraseSchedule;
	
	
	
	
	public function __construct( $id = '' ) {
		if($id != null){		
			parent::__construct( $id );			
			$this->isPickupClient = get_post_meta( $id, '_'.'isPickupClient', true);
			$this->kpname = get_post_meta( $id, '_'.'kpname',true );
			$this->shortkpid = get_post_meta( $id, '_'.'shortkpid',true );
			$this->street = get_post_meta( $id, '_'.'street',true );
			$this->zip = get_post_meta( $id, '_'.'zip',true );
			$this->city = get_post_meta( $id, '_'.'city',true );
			$this->locationhint = get_post_meta( $id, '_'.'locationhint',true );
			$this->totalPhraseSchedule = get_post_meta( $id, '_'.'totalPhraseSchedule',true );			
		}		
	}
	

	
	
	function getisPickupClient(){                   				return $this->isPickupClient; }
	function getkpname(){                   						return $this->kpname; }
	function getshortkpid(){                   						return $this->shortkpid; }
	function getstreet(){                   						return $this->street; }
	function getzip(){                   							return $this->zip; }
	function getcity(){                   							return $this->city; }
	function getlocationhint(){                   					return $this->locationhint; }
	function gettotalPhraseSchedule(){                   			return $this->totalPhraseSchedule; }
	
	function setisPickupClient($isPickupClient) {					$this->isPickupClient = $isPickupClient; }
	function setkpname($kpname) {									$this->kpname = $kpname; }
	function setshortkpid($shortkpid) {								$this->shortkpid = $shortkpid; }
	function setstreet($street) {									$this->street = $street; }
	function setzip($zip) {											$this->zip = $zip; }
	function setcity($city) {										$this->city = $city; }
	function setlocationhint($locationhint) {						$this->locationhint = $locationhint; }
	function settotalPhraseSchedule($totalPhraseSchedule) {			$this->totalPhraseSchedule = $totalPhraseSchedule; }


	
	function save(){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}

		$order_id = $this->id;
		parent::save();
		update_post_meta($order_id, '_'.'isPickupClient', $this->isPickupClient );
		update_post_meta($order_id, '_'.'kpname', $this->kpname );
		update_post_meta($order_id, '_'.'shortkpid', $this->shortkpid );
		update_post_meta($order_id, '_'.'street', $this->street );
		update_post_meta($order_id, '_'.'zip', $this->zip );
		update_post_meta($order_id, '_'.'city', $this->city );
		update_post_meta($order_id, '_'.'locationhint', $this->locationhint );
		update_post_meta($order_id, '_'.'totalPhraseSchedule', $this->totalPhraseSchedule );


		return $order_id;		
		
	
	}

	
	
	

}
	