<?php
if ( ! defined( 'ABSPATH' ) )
	exit;


Class gootracking_email{

	private $typeEmail;
	private $order;
	private $htmlLink;
	private $labelLink;

	function __construct($order_id){
		$order = new WC_Order( $order_id );
		$this->order = $order;
	}
	
	function generateLink() {
		$order = $this->order;
		$order_id = $order->id;
		$oWC_Order_Custom = new gootracking_WC_Order_Custom( $order_id );

		if($this->typeEmail == 'feedback') {
			$this->labelLink = (__( 'Send us a feedback!', 'gootracking' ));
			$link = add_query_arg('gootrackingAction', 'showFeedback', $order->get_view_order_url());
		} else {
			$link = $order->get_view_order_url();
		}

		if($this->labelLink == '' ) {
			if ($oWC_Order_Custom->getshippingType() == 'quote') {
				$labelLink = __( 'Pay or reject this quote online', 'gootracking-for-woocommerce' );
			} else if($oWC_Order_Custom->getshippingType() == 'returnToFinalCust') {
				$labelLink = __( 'See this return order online', 'gootracking-for-woocommerce' );
			} else {
				$labelLink = __( 'See this order online', 'gootracking-for-woocommerce' );
			}
		} else {
			$labelLink = $this->labelLink;
		}

		

		$htmlLink = '<h4>';
		$htmlLink .= '<a href="'. $link .'">'. $labelLink . '</a>';
		$htmlLink .= '</h4>';
		$this->htmlLink = $htmlLink;		
	}
	function showLink() {
		echo $this->htmlLink;
	}
	function getLink() {
		return $this->htmlLink;
	}

	function setlabelLink($labelLink) {				$this->labelLink = $labelLink; }
	function settypeEmail($typeEmail) {				$this->typeEmail = $typeEmail; }

	function sendEmail() {
   		global $woocommerce;
	    // Get order object.
	    //$order = new WC_Order( $order_id );
	    $order = $this->order;
	    // Create a mailer
	    $mailer = $woocommerce->mailer();
	   
	    if($this->typeEmail == 'feedback') {
		    
		    $this->generateLink();	    	
	   		$message_body = __( 'Hi there. Your recent order on UPS-acces-point has been completed. Now We need you! Can you send us a feedback of your experience on this website?' ,  'gootracking' ) . $this->getLink() ;
	   		$message_head = sprintf( __( 'Order %s is complete! Your feedback', 'gootracking'  ), $order->get_order_number() );
	   	}
	    $message = $mailer->wrap_message(
	        // Message head and message body.
	        $message_head, $message_body 
	    );
	    // Cliente email, email subject and message.
	    $mailer->send( $order->billing_email, $message_head, $message );	
	}

}



Class gootracking_show_link_view_order{



	function __construct($order){
		$this->order = $order;

	}

	
}