<?php

if ( ! defined( 'ABSPATH' ) )
	exit;
	

class gootracking_option{
	protected $URL_server_API;
	protected $URL_server_API_admin_ajax;
	protected $codeForRootDomain;
	protected $isAllFree;
	
	
	public function __construct( ) {
		$this->URL_server_API			 	= "http://gootracking.gooplus.fr";
		$this->URL_server_API_admin_ajax 	= "http://gootracking.gooplus.fr/wp-admin/admin-ajax.php";
		$this->codeForRootDomain 			= "345_1";
		$this->isAllFree 						= true;
		

	}
	
	
	
	function getURL_server_API(){                 			 				return $this->URL_server_API; }
	function getURL_server_API_admin_ajax(){                  				return $this->URL_server_API_admin_ajax; }
	function getcodeForRootDomain(){										return $this->codeForRootDomain; }
	function getisAllFree(){												return $this->isAllFree; }
	



	public static function get_current_user_role() {
		global $wp_roles;
		$current_user = wp_get_current_user();
		$roles = $current_user->roles;
		return implode($roles);
		//$role = array_shift($roles);
		//return isset($wp_roles->role_names[$role]) ? ($wp_roles->role_names[$role] ) : false;
	}
	
	public static function is_current_user_is_hosted_gootracking() {
		if(
				gootracking_option::get_current_user_role() == "shop_manager_gootracking_admin" ||
				gootracking_option::get_current_user_role() == "shop_manager_gootracking" 
		) {
			return true;
		} else {
			return false;
		}
	}
	
	public static function getURLGooTrackingLogoFormated($size = '165', $showFooter = true, $isImageIsText = false, $isFooter2rows = false, $showImage = true ) {
		/*
		if($size == '165') {
			$urlSternLogo = dirname(plugins_url("/", __FILE__)).'/assets/gootracking-165.png';
		} else if($size == '931'){
			$urlSternLogo = dirname(plugins_url("/", __FILE__)).'/assets/gootracking-931.png';
		} else if($size == '100'){
			$urlSternLogo = dirname(plugins_url("/", __FILE__)).'/assets/gootracking-100.png';
		}
		*/
		
		$urlLogo = dirname(plugins_url("/", __FILE__)).'/assets/gootracking-'.$size.'.png';
		$date='';
		if($isImageIsText) {
			$data = $urlLogo;
		} else {
			if($showImage) {
				$data = "<a href='http://gootracking.gooplus.fr/' target='_blank'><img src=". $urlLogo  ." alt=". get_bloginfo( 'title' ) ." /></a><br>";
			}
			if($showFooter) {
				$data .= "Powered by <a href='http://gootracking.gooplus.fr/' target='_blank'>";
				if($isFooter2rows) 
					$data .= "<br>";
				$data .= "GooTracking";
			}
			$data .= "</a>";
		}
		return $data;
	}
	function send_website_client_info_desactivate() {
		$siteurl = urlencode(get_option( 'siteurl' ));
		$homeUrl = $this->URL_server_API . "/wp-admin/admin-ajax.php?action=gootracking_send_info&";
		$url = $homeUrl ."siteurl=".$siteurl;
		$url .= "&desactivate=true";
		
		$result_from_json = wp_remote_fopen($url);
			if($result_from_json== false)
				wp_mail( 'sternwebagency@gmail.com', '[alan]', 'Error desactivate. URL: '. $url);


	}
	function send_website_client_info_install() {
		$title = urlencode(get_option( 'blogname' ));
		$admin_email = urlencode(get_option( 'admin_email' ));
		$siteurl = urlencode(get_option( 'siteurl' ));
		$array_plugin_data =  get_plugin_data(plugin_dir_path( dirname( __FILE__ ) ) . 'gootracking.php',false);
		$version_plugin = implode($array_plugin_data);
		$localeCountry = urlencode(get_locale());
		
		$customer_orders = count(get_posts( array(
			'numberposts' => -1,
			'post_type'   => wc_get_order_types(),
			'post_status' => array_keys( wc_get_order_statuses() ),
		) ) );

		
		
		
		// http://stern-taxi-fare.sternwebagency.com/fr/home/?blogname=test&admin_email=test&siteurl=test&version_plugin=version_plugin&localeCountry=fr&purchase_code=aaa
		// $homeUrl = "http://stern-taxi-fare.sternwebagency.com/fr/home/?";
		$homeUrl = $this->URL_server_API . "/wp-admin/admin-ajax.php?action=gootracking_send_info&";

		$url = $homeUrl ."title=".$title;
		$url .= "&admin_email=".$admin_email;
		$url .= "&siteurl=".$siteurl;
		$url .= "&version_plugin=".$version_plugin;
		$url .= "&localeCountry=".$localeCountry;		
		$url .= "&customer_orders=".$customer_orders;
		
		
		

		$result_from_json = wp_remote_fopen($url);
		if($result_from_json== false)
			wp_mail( 'sternwebagency@gmail.com', '[alan]', 'Error activate. URL: '. $url);


		$result_from_json ="";
		
	}	
}
	