<?php

if ( ! defined( 'ABSPATH' ) )
	exit;

/**
 * Event admin
 */
class gootracking_events_Admin {

	/**
	 * Constructor
	 */
	public function __construct() {
		add_action('admin_menu', array( $this,'register_gootracking_acces_point') );			
		add_action('admin_menu', array( $this,'register_submenu_GooTrackingShip') );
		add_action('admin_menu', array( $this,'register_submenu_createProducts') );
	//	add_action('admin_menu', array( $this,'register_submenu_questionFeedback') );
		/*
	
		
		add_action('admin_menu', array( $this,'register_submenu_type_car') );		
		add_action('admin_menu', array( $this,'register_submenu_rule') );
		add_action('admin_menu', array( $this,'register_submenu_listAddress') );
		add_action('admin_menu', array( $this,'register_submenu_calendar') );
		*/
		
	}
	
	/*
	public function create_post_type_car($cartype,$carfare,$carseat,$suitcases){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}
		$post = array(
			'post_author' => $userID,
			'post_content' => '',
			'post_status' => 'publish',
			'post_title' => 'stern_taxi_car_type',
			'post_type' => 'stern_taxi_car_type',
		);

		$post_id = wp_insert_post($post);  
		update_post_meta($post_id, '_stern_taxi_car_type_cartype', $cartype);
		update_post_meta($post_id, '_stern_taxi_car_type_carfare', $carfare);
		update_post_meta($post_id, '_stern_taxi_car_type_carseat', $carseat);
		update_post_meta($post_id, '_stern_taxi_car_type_suitcases', $suitcases);
		
		
		return $post_id;
	}
*/
	

		

	public function register_gootracking_acces_point(){
		add_menu_page( 'GooTracking', 'GooTracking', 'manage_woocommerce', 'GooTracking', array( $this,'menu_page_gootracking_acces_point'), "", 6 ); 
	}
	

	public function register_submenu_GooTrackingShip() {
		add_submenu_page( 'GooTracking', 'GooTrackingShip', 'GooTrackingShip', 'manage_woocommerce', 'gootracking-GooTrackingShip', array( $this,'gootracking_submenu_page_callback_GooTrackingShip')  );
	}
	public function register_submenu_createProducts() {
		add_submenu_page( 'GooTracking', 'GooTrackingCreateProducts', 'GooTrackingCreateProducts', 'manage_woocommerce', 'gootracking-create-products', array( $this,'gootracking_submenu_page_callback_createProducts')  );
	}
/*
	public function register_submenu_questionFeedback() {
		add_submenu_page( 'GooTracking', 'GooTrackingQuestionFeedback', 'QuestionFeedback', 'manage_woocommerce', 'gootracking-QuestionFeedback', array( $this,'gootracking_submenu_page_callback_QuestionFeedback')  );
	}


	public function gootracking_submenu_page_callback_QuestionFeedback(){
		if(isset($_POST['saveQuestionFeedback']) ) {
        	$inputQuestionFeedback = $_POST['inputQuestionFeedback'];
        	$splitcontents = explode("\n", $inputQuestionFeedback);
			$row=0;
			$rowOk=0;       	
        	foreach ( $splitcontents as $line ) {
				$row++;
				if($row > 200) {
					echo   __( 'Limit Max reached','gootracking' );
					break;
				}
				$line =  str_replace('+', "\t", $line);
				$parts = preg_split('/[\t]/', $line);

				$titleQuestion 	= $parts[0];
				$nameQuestion 	= $parts[1];
				$typeField 		= $parts[2];

				$oOption = new gootracking_option();
				$oOption->incrementArrayQuestionFeedback($titleQuestion, $nameQuestion, $typeField);



	        	if($post_id != 0)
						$rowOk++;
			}

			if($rowOk>0) {
				echo $rowOk."/".$row. " ". __( 'Rows updated','gootracking' );	
			}	

        }		
		new gootracking_questionFeedback("600px","300px",true);
	}
*/
	public function gootracking_submenu_page_callback_createProducts(){		
		if(isset($_POST['saveCreateProducts']) ) {
        	$inputCreateProducts = $_POST['inputCreateProducts'];
        	$splitcontents = explode("\n", $inputCreateProducts);
			$row=0;
			$rowOk=0;       	
        	foreach ( $splitcontents as $line ) {
				$row++;
				if($row > 200) {
					echo   __( 'Limit Max reached','gootracking' );
					break;
				}
				$line =  str_replace('+', "\t", $line);
				$parts = preg_split('/[\t]/', $line);

				if (!isset($parts[0]) or !isset($parts[1])) {
					echo   __( 'Error: 2 colums of data must be set','gootracking' );
					break;
				}
				if (isset($parts[2])) {
					echo   __( 'ErrorToo many columns!','gootracking' );
					break;					
				}

				$oWC_Product_Custom = new gootracking_WC_Product_Custom();
				$oWC_Product_Custom->settitle($parts[0]);
				$oWC_Product_Custom->setprice($parts[1]);

				$post_id = $oWC_Product_Custom->gootracking_create_product();
	        	echo  __( 'NewProductId:','gootracking' ) . $post_id. ' ' ;
	        	if($post_id != 0)
						$rowOk++;
			}

			if($rowOk>0) {
				echo $rowOk."/".$row. " ". __( 'Rows updated','gootracking' );	
			}	

        }

		new gootracking_create_products("600px","300px",true);
	}
	
		
	public function gootracking_submenu_page_callback_GooTrackingShip(){
		if (($_SERVER['REQUEST_METHOD'] == 'POST') && isset($_POST['SternSaveSettings']) ) 
        {		
			gootracking_update_options();
		}
		
		new gootracking_ship_method("600px","300px",true);
	}
	



	public function menu_page_gootracking_acces_point(){
		
		if (($_SERVER['REQUEST_METHOD'] == 'POST') && isset($_POST['SternSaveSettings']) ) 
        {		
			gootracking_update_options();
			gootracking_saveVersion();
		//	sendInfosDebug();

		}
		/*
		
		if (($_SERVER['REQUEST_METHOD'] == 'POST') && isset($_POST['initVal']) ) 
        {

			
			$beginNameOption = "gootracking_acces_point%";
			global $wpdb;
			$wpdb->query($wpdb->prepare("DELETE FROM $wpdb->options WHERE option_name like %s",$beginNameOption));
		
						
					
		}
		if (($_SERVER['REQUEST_METHOD'] == 'POST') && isset($_POST['createProduct']) ) 
        {
			gootracking_createProductAndSaveId();			
			
		}		
		*/
		
		
		new gootracking_settings("600px","300px",true);
	}




}

new gootracking_events_Admin();