<?php

if ( ! defined( 'ABSPATH' ) )
	exit;






/**
 * Add the field to the checkout
 */
add_action( 'woocommerce_after_order_notes', 'gootracking_checkout_field' );
function gootracking_checkout_field( $checkout ) {

	$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );	
	new gootracking_checkout( $oWC_Order_Custom );
	new gootracking_checkoutUPS($checkout, $oWC_Order_Custom);
}


add_action( 'woocommerce_checkout_process', 'gootracking_woocommerce_checkout_process',10 );
function gootracking_woocommerce_checkout_process() {
	/*
	if(gootracking_WC_Order_Custom::isSessionShippingType("UPS")){
		$opdfUPS = new gootracking_pdfUPS();
		$opdfUPS->setURL("UPS.pdf");
		$opdfUPS->settypePDF("pdfUPS");
		$opdfUPS->setURLAPI();
		$arrayStatus = $opdfUPS->statusUPSLabel();
		//var_dump($arrayStatus );
		if($arrayStatus['status'] !="Success" ) {
			wc_add_notice( '<strong>' .  __( 'Error UPS', 'gootracking' )  . '</strong> ' . $arrayStatus['resp'], 'error'  );
			var_dump($arrayStatus);
		} else {
			
		}
		//var_dump($_POST );
		
	}
	*/
}



/*
* We launch the PickupClient process ONLY if order is in status processising. (paid)
*/
add_action( 'woocommerce_order_status_processing', 'gootracking_order_status_processing' );
function gootracking_order_status_processing( $order_id ) {

	
}
	
	
	
add_action( 'woocommerce_checkout_update_order_meta', 'gootracking_checkout_field_update_order_meta' );
//add_action( 'mysite_woocommerce_order_status_completed', 'gootracking_checkout_field_update_order_meta' );
function gootracking_checkout_field_update_order_meta( $order_id ) {

	if( $order_id=="") {
		return;
	}
	$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
	if(!is_object ( $oWC_Order_Custom)) {
		return;
	}	
	if($oWC_Order_Custom->getshippingType()=="")
		return;
	if($oWC_Order_Custom->getshippingType()=="UPS") {
		if($oWC_Order_Custom->getIdPDFPickupClient() != '')
		return;	
	}

	$IdPdfLabel="";
	$IdPdfCustom ="";	
	
	$oWC_Order_Custom->setId($order_id);
	$oWC_Order_Custom->save();
	
	
	
	$opdfUPS = new gootracking_pdfUPS();
	$opdfUPS->setorder_id($order_id);
	$opdfUPS->setURL("CustomPDF.pdf");
	$opdfUPS->settypePDF("pdfCustom");
	$opdfUPS->savePDFCustomToServer();
	$IdPdfCustom = $opdfUPS->save();	
	$oWC_Order_Custom->setIdPdfCustom($IdPdfCustom);

	if(gootracking_WC_Order_Custom::isSessionShippingType("UPS", $oWC_Order_Custom)){
		$opdfUPS = new gootracking_pdfUPS();
		$opdfUPS->setorder_id($order_id);
		$opdfUPS->setURL("UPS.pdf");
		$opdfUPS->settypePDF("pdfUPS");
		$opdfUPS->setURLAPI();
		$opdfUPS->getRespUPS();		
		$opdfUPS->saveUPSLabelToServer();
		$IdPdfLabel = $opdfUPS->save();	
		$oWC_Order_Custom->setIdPdfLabel($IdPdfLabel);
		$oWC_Order_Custom->save();
	}
	

	if(gootracking_WC_Order_Custom::isSessionShippingType("Kiala", $oWC_Order_Custom)){
		//if(copyAccesPointToServer($URLUPS_acces_point, $filename, $pathFile)) {	
			$opdfUPS = new gootracking_pdfUPS();
			$opdfUPS->setorder_id($order_id);
			$opdfUPS->setURL("Kiala.pdf");
			$opdfUPS->settypePDF("pdfKiala");
			$opdfUPS->saveKialaToServer();
			$IdPdfLabel = $opdfUPS->save();	
			$oWC_Order_Custom->setIdPdfLabel($IdPdfLabel);
	//	}
	}
	$oWC_Order_Custom->save();
/*	
//	var_dump($IdPDFPickupClient);
//	var_dump("aaaaaaaaaaaaa");
//	var_dump($oWC_Order_Custom->GetIdPDFPickupClient());
	
	$oWC_Order_Custom;
	$oWC_Order_Custom = new gootracking_WC_Order_Custom_UPS($order_id);
	var_dump($oWC_Order_Custom);
//	var_dump($oWC_Order_Custom->GetIdPDFPickupClient());
	
	
	//	$IdPDFPickupClient = $this->IdPDFPickupClient;
		$opdfUPS = new gootracking_pdfUPS($IdPDFPickupClient );
		$PRN = $opdfUPS->getPRN();
		//$RateStatus = $opdfUPS->getRateStatus();
		//$resp = $opdfUPS->getresp();
		var_dump("cest la vie");
		var_dump($opdfUPS);
*/		
//throw new Exception( '<strong>' .  __('Error Pick Up Client UPS', 'gootracking' )  . '</strong> '  . "bbb");

//	wp_mail( 'sternwebagency@gmail.com', '[alan]', '1');

	if( $order_id=="") 
		return;
	$oWC_Order_Custom = gootracking_WC_Order_Custom::getCorrectInstanceOf_WC_Order_Custom( $order_id );


	if(!is_object ( $oWC_Order_Custom)) 
		return;

	
	if($oWC_Order_Custom->getshippingType()=="UPS") {
		if($oWC_Order_Custom->getIdPDFPickupClient() != '')
		return;	
	}
	
	if(gootracking_WC_Order_Custom::isSessionShippingType("UPS", $oWC_Order_Custom)){
		
		if($oWC_Order_Custom->getisPickupClient()==true) {
			
			if($oWC_Order_Custom->getIdPDFPickupClient!= '') {
				return;
			}			
			
			
			$opdfUPS = new gootracking_pdfUPS();
			$opdfUPS->setorder_id($order_id);
			//$opdfUPS->setURL("UPSPickupClient.pdf");
			$opdfUPS->settypePDF("pdfUPSPickupClient");
			$opdfUPS->setURLAPI();
			$opdfUPS->getRespUPS();
			$opdfUPS->setPRN();
			$opdfUPS->setRateStatus();
			//$oWC_Order_Custom->save();
			$IdPDFPickupClient = $opdfUPS->save();
			$oWC_Order_Custom->setIdPDFPickupClient($IdPDFPickupClient);
			$oWC_Order_Custom->save();
			
		}		
	}
}