<?php

if ( ! defined( 'ABSPATH' ) )
	exit;


/*
remove_role( 'shop_manager_admin' ); 
add_role('shop_manager_admin', 'shop Manager Admin', array(
    'read' => true, // True allows that capability
    'edit_posts' => true,
    'delete_posts' => true, // Use false to explicitly deny
    'manage_woocommerce' => true,
  //  'view_woocommerce_reports' => true,
    'manage_woocommerce_orders' => true,
    'manage_woocommerce_coupons' => true,
    'manage_woocommerce_products' => true,
    'edit_shop_order' => true,
    'edit_shop_orders' => true,
	'read_shop_order' => true,

));
*/

add_action('init', 'gootracking_roles');
function gootracking_roles()
{
    global $wp_roles;
    if ( ! isset( $wp_roles ) )
        $wp_roles = new WP_Roles();

    $adm = $wp_roles->get_role('shop_manager');

	$role = 'shop_manager_gootracking_admin';
	$nameRole = 'shop Manager Gootracking Admin';
//	remove_role( $role ); 	
    $wp_roles->add_role($role, $nameRole, $adm->capabilities);
    $wp_roles->add_cap( $role, 'view_woocommerce_reports' );  
    $wp_roles->add_cap( $role, 'create_users' );  


	$role = 'shop_manager_gootracking';
	$nameRole = 'shop Manager Gootracking';
//	remove_role( $role ); 	
    $wp_roles->add_role($role, $nameRole, $adm->capabilities);
    $wp_roles->remove_cap( $role, 'manage_woocommerce' );
    
    $wp_roles->remove_cap( $role, 'view_woocommerce_reports' );    
    $wp_roles->remove_cap( $role, 'edit_shop_coupon' );
    $wp_roles->remove_cap( $role, 'read_shop_coupon' );
    $wp_roles->remove_cap( $role, 'delete_shop_coupon' );
    $wp_roles->remove_cap( $role, 'edit_shop_coupons' );
    $wp_roles->remove_cap( $role, 'edit_others_shop_coupons' );
    $wp_roles->remove_cap( $role, 'read_private_shop_coupons' );
    $wp_roles->remove_cap( $role, 'manage_shop_coupon_terms' );
    $wp_roles->remove_cap( $role, 'read_product' );
    $wp_roles->remove_cap( $role, 'edit_product' );
    $wp_roles->remove_cap( $role, 'edit_products' );
    $wp_roles->remove_cap( $role, 'edit_others_products' );
    $wp_roles->remove_cap( $role, 'delete_product' );
    $wp_roles->remove_cap( $role, 'publish_products' );
    $wp_roles->remove_cap( $role, 'read_private_products' );
    $wp_roles->remove_cap( $role, 'delete_products' );
    $wp_roles->remove_cap( $role, 'delete_private_products' );
    $wp_roles->remove_cap( $role, 'manage_product_terms' );
    $wp_roles->remove_cap( $role, 'edit_product_terms' );
    $wp_roles->remove_cap( $role, 'delete_product_terms' );
    $wp_roles->remove_cap( $role, 'assign_product_terms' );


 
	

/*
object(WP_Role)#392 (2) { ["name"]=> string(12) "shop_manager" ["capabilities"]=> array(110) { ["level_9"]=> bool(true) ["level_8"]=> bool(true) ["level_7"]=> bool(true) ["level_6"]=> bool(true) ["level_5"]=> bool(true) ["level_4"]=> bool(true) ["level_3"]=> bool(true) ["level_2"]=> bool(true) ["level_1"]=> bool(true) ["level_0"]=> bool(true) ["read"]=> bool(true) ["read_private_pages"]=> bool(true) ["read_private_posts"]=> bool(true) ["edit_users"]=> bool(true) ["edit_posts"]=> bool(true) ["edit_pages"]=> bool(true) ["edit_published_posts"]=> bool(true) ["edit_published_pages"]=> bool(true) ["edit_private_pages"]=> bool(true) ["edit_private_posts"]=> bool(true) ["edit_others_posts"]=> bool(true) ["edit_others_pages"]=> bool(true) ["publish_posts"]=> bool(true) ["publish_pages"]=> bool(true) ["delete_posts"]=> bool(true) ["delete_pages"]=> bool(true) ["delete_private_pages"]=> bool(true) ["delete_private_posts"]=> bool(true) ["delete_published_pages"]=> bool(true) ["delete_published_posts"]=> bool(true) ["delete_others_posts"]=> bool(true) ["delete_others_pages"]=> bool(true) ["manage_categories"]=> bool(true) ["manage_links"]=> bool(true) ["moderate_comments"]=> bool(true) ["unfiltered_html"]=> bool(true) ["upload_files"]=> bool(true) ["export"]=> bool(true) ["import"]=> bool(true) ["list_users"]=> bool(true) ["manage_woocommerce"]=> bool(true) ["view_woocommerce_reports"]=> bool(true) ["edit_product"]=> bool(true) ["read_product"]=> bool(true) ["delete_product"]=> bool(true) ["edit_products"]=> bool(true) ["edit_others_products"]=> bool(true) ["publish_products"]=> bool(true) ["read_private_products"]=> bool(true) ["delete_products"]=> bool(true) ["delete_private_products"]=> bool(true) ["delete_published_products"]=> bool(true) ["delete_others_products"]=> bool(true) ["edit_private_products"]=> bool(true) ["edit_published_products"]=> bool(true) ["manage_product_terms"]=> bool(true) ["edit_product_terms"]=> bool(true) ["delete_product_terms"]=> bool(true) ["assign_product_terms"]=> bool(true) ["edit_shop_order"]=> bool(true) ["read_shop_order"]=> bool(true) ["delete_shop_order"]=> bool(true) ["edit_shop_orders"]=> bool(true) ["edit_others_shop_orders"]=> bool(true) ["publish_shop_orders"]=> bool(true) ["read_private_shop_orders"]=> bool(true) ["delete_shop_orders"]=> bool(true) ["delete_private_shop_orders"]=> bool(true) ["delete_published_shop_orders"]=> bool(true) ["delete_others_shop_orders"]=> bool(true) ["edit_private_shop_orders"]=> bool(true) ["edit_published_shop_orders"]=> bool(true) ["manage_shop_order_terms"]=> bool(true) ["edit_shop_order_terms"]=> bool(true) ["delete_shop_order_terms"]=> bool(true) ["assign_shop_order_terms"]=> bool(true) ["edit_shop_coupon"]=> bool(true) ["read_shop_coupon"]=> bool(true) ["delete_shop_coupon"]=> bool(true) ["edit_shop_coupons"]=> bool(true) ["edit_others_shop_coupons"]=> bool(true) ["publish_shop_coupons"]=> bool(true) ["read_private_shop_coupons"]=> bool(true) ["delete_shop_coupons"]=> bool(true) ["delete_private_shop_coupons"]=> bool(true) ["delete_published_shop_coupons"]=> bool(true) ["delete_others_shop_coupons"]=> bool(true) ["edit_private_shop_coupons"]=> bool(true) ["edit_published_shop_coupons"]=> bool(true) ["manage_shop_coupon_terms"]=> bool(true) ["edit_shop_coupon_terms"]=> bool(true) ["delete_shop_coupon_terms"]=> bool(true) ["assign_shop_coupon_terms"]=> bool(true) ["edit_shop_webhook"]=> bool(true) ["read_shop_webhook"]=> bool(true) ["delete_shop_webhook"]=> bool(true) ["edit_shop_webhooks"]=> bool(true) ["edit_others_shop_webhooks"]=> bool(true) ["publish_shop_webhooks"]=> bool(true) ["read_private_shop_webhooks"]=> bool(true) ["delete_shop_webhooks"]=> bool(true) ["delete_private_shop_webhooks"]=> bool(true) ["delete_published_shop_webhooks"]=> bool(true) ["delete_others_shop_webhooks"]=> bool(true) ["edit_private_shop_webhooks"]=> bool(true) ["edit_published_shop_webhooks"]=> bool(true) ["manage_shop_webhook_terms"]=> bool(true) ["edit_shop_webhook_terms"]=> bool(true) ["delete_shop_webhook_terms"]=> bool(true) ["assign_shop_webhook_terms"]=> bool(true) } }


// admin

object(WP_Role)#400 (2) { ["name"]=> string(13) "administrator" ["capabilities"]=> array(138) { ["switch_themes"]=> bool(true) ["edit_themes"]=> bool(true) ["activate_plugins"]=> bool(true) ["edit_plugins"]=> bool(true) ["edit_users"]=> bool(true) ["edit_files"]=> bool(true) ["manage_options"]=> bool(true) ["moderate_comments"]=> bool(true) ["manage_categories"]=> bool(true) ["manage_links"]=> bool(true) ["upload_files"]=> bool(true) ["import"]=> bool(true) ["unfiltered_html"]=> bool(true) ["edit_posts"]=> bool(true) ["edit_others_posts"]=> bool(true) ["edit_published_posts"]=> bool(true) ["publish_posts"]=> bool(true) ["edit_pages"]=> bool(true) ["read"]=> bool(true) ["level_10"]=> bool(true) ["level_9"]=> bool(true) ["level_8"]=> bool(true) ["level_7"]=> bool(true) ["level_6"]=> bool(true) ["level_5"]=> bool(true) ["level_4"]=> bool(true) ["level_3"]=> bool(true) ["level_2"]=> bool(true) ["level_1"]=> bool(true) ["level_0"]=> bool(true) ["edit_others_pages"]=> bool(true) ["edit_published_pages"]=> bool(true) ["publish_pages"]=> bool(true) ["delete_pages"]=> bool(true) ["delete_others_pages"]=> bool(true) ["delete_published_pages"]=> bool(true) ["delete_posts"]=> bool(true) ["delete_others_posts"]=> bool(true) ["delete_published_posts"]=> bool(true) ["delete_private_posts"]=> bool(true) ["edit_private_posts"]=> bool(true) ["read_private_posts"]=> bool(true) ["delete_private_pages"]=> bool(true) ["edit_private_pages"]=> bool(true) ["read_private_pages"]=> bool(true) ["delete_users"]=> bool(true) ["create_users"]=> bool(true) ["unfiltered_upload"]=> bool(true) ["edit_dashboard"]=> bool(true) ["update_plugins"]=> bool(true) ["delete_plugins"]=> bool(true) ["install_plugins"]=> bool(true) ["update_themes"]=> bool(true) ["install_themes"]=> bool(true) ["update_core"]=> bool(true) ["list_users"]=> bool(true) ["remove_users"]=> bool(true) ["promote_users"]=> bool(true) ["edit_theme_options"]=> bool(true) ["delete_themes"]=> bool(true) ["export"]=> bool(true) ["manage_woocommerce"]=> bool(true) ["view_woocommerce_reports"]=> bool(true) ["edit_product"]=> bool(true) ["read_product"]=> bool(true) ["delete_product"]=> bool(true) ["edit_products"]=> bool(true) ["edit_others_products"]=> bool(true) ["publish_products"]=> bool(true) ["read_private_products"]=> bool(true) ["delete_products"]=> bool(true) ["delete_private_products"]=> bool(true) ["delete_published_products"]=> bool(true) ["delete_others_products"]=> bool(true) ["edit_private_products"]=> bool(true) ["edit_published_products"]=> bool(true) ["manage_product_terms"]=> bool(true) ["edit_product_terms"]=> bool(true) ["delete_product_terms"]=> bool(true) ["assign_product_terms"]=> bool(true) ["edit_shop_order"]=> bool(true) ["read_shop_order"]=> bool(true) ["delete_shop_order"]=> bool(true) ["edit_shop_orders"]=> bool(true) ["edit_others_shop_orders"]=> bool(true) ["publish_shop_orders"]=> bool(true) ["read_private_shop_orders"]=> bool(true) ["delete_shop_orders"]=> bool(true) ["delete_private_shop_orders"]=> bool(true) ["delete_published_shop_orders"]=> bool(true) ["delete_others_shop_orders"]=> bool(true) ["edit_private_shop_orders"]=> bool(true) ["edit_published_shop_orders"]=> bool(true) ["manage_shop_order_terms"]=> bool(true) ["edit_shop_order_terms"]=> bool(true) ["delete_shop_order_terms"]=> bool(true) ["assign_shop_order_terms"]=> bool(true) ["edit_shop_coupon"]=> bool(true) ["read_shop_coupon"]=> bool(true) ["delete_shop_coupon"]=> bool(true) ["edit_shop_coupons"]=> bool(true) ["edit_others_shop_coupons"]=> bool(true) ["publish_shop_coupons"]=> bool(true) ["read_private_shop_coupons"]=> bool(true) ["delete_shop_coupons"]=> bool(true) ["delete_private_shop_coupons"]=> bool(true) ["delete_published_shop_coupons"]=> bool(true) ["delete_others_shop_coupons"]=> bool(true) ["edit_private_shop_coupons"]=> bool(true) ["edit_published_shop_coupons"]=> bool(true) ["manage_shop_coupon_terms"]=> bool(true) ["edit_shop_coupon_terms"]=> bool(true) ["delete_shop_coupon_terms"]=> bool(true) ["assign_shop_coupon_terms"]=> bool(true) ["edit_shop_webhook"]=> bool(true) ["read_shop_webhook"]=> bool(true) ["delete_shop_webhook"]=> bool(true) ["edit_shop_webhooks"]=> bool(true) ["edit_others_shop_webhooks"]=> bool(true) ["publish_shop_webhooks"]=> bool(true) ["read_private_shop_webhooks"]=> bool(true) ["delete_shop_webhooks"]=> bool(true) ["delete_private_shop_webhooks"]=> bool(true) ["delete_published_shop_webhooks"]=> bool(true) ["delete_others_shop_webhooks"]=> bool(true) ["edit_private_shop_webhooks"]=> bool(true) ["edit_published_shop_webhooks"]=> bool(true) ["manage_shop_webhook_terms"]=> bool(true) ["edit_shop_webhook_terms"]=> bool(true) ["delete_shop_webhook_terms"]=> bool(true) ["assign_shop_webhook_terms"]=> bool(true) ["wplc_ma_agent"]=> bool(true) ["edit_wplc_quick_response"]=> bool(true) ["edit_other_wplc_quick_response"]=> bool(true) ["publish_wplc_quick_response"]=> bool(true) ["read_wplc_quick_response"]=> bool(true) ["read_private_wplc_quick_response"]=> bool(true) ["delete_wplc_quick_response"]=> bool(true) } }



*/    

}





add_action( 'init', 'gootracking_saveShippingType' );
function gootracking_saveShippingType(){	
	if(isset($_GET['shippingType'])) {
		global $woocommerce;
		if ( ! headers_sent() )  {
			//global $woocommerce;
			$woocommerce->session->set_customer_session_cookie(true);
		}		
		//$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
		
		//if(!is_object ( $oWC_Order_Custom )) {
		//	$oWC_Order_Custom = new gootracking_WC_Order_Custom();
		//}
		if($_GET['shippingType']=="Kiala") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_Kiala();
			$oWC_Order_Custom->setshippingType("Kiala");
			WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );
//var_dump($oWC_Order_Custom);			
		}
		if($_GET['shippingType']=="personal") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom();
			$oWC_Order_Custom->setshippingType("personal");			
			$idProduct = get_option('gootracking_product_id_personal');	
			$urlProduct = esc_url( get_permalink($idProduct) );					
			if($urlProduct!="") {				
				WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );	
				wp_safe_redirect( $urlProduct );
				exit;
			}
		}
		if($_GET['shippingType']=="UPS") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_UPS();
			$oWC_Order_Custom->setshippingType("UPS");
			$oWC_Order_Custom->setisPickupClient(false);
			$idProduct = get_option('gootracking_product_id_UPS');
			$urlProduct = esc_url( get_permalink($idProduct) );
			if($urlProduct!="") {				
				WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );	
				wp_safe_redirect( $urlProduct );
				exit;
			}				
		}
		if($_GET['shippingType']=="UPSAndPickupClient") {
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_UPS();
			$oWC_Order_Custom->setshippingType("UPS");
			$oWC_Order_Custom->setisPickupClient(true);
			$idProduct = get_option('gootracking_product_id_UPS');
			$urlProduct = esc_url( get_permalink($idProduct) );
			if($urlProduct!="") {				
				WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );	
				wp_safe_redirect( $urlProduct );
				exit;
			}
		}		
	}
}







add_action('init', 'gootracking_register_shortcodes');
function gootracking_register_shortcodes() {
    add_shortcode('GooTracking', 'gootracking_function_shortcodes');	
}
			
function gootracking_function_shortcodes($atts) {
	ob_start();
	if ( gootracking_isWooCommerceActive() ) {
			
		if(get_option('gootracking_country')!="") {

			gootracking_showForm1($atts);
		} else {
			echo __('GooTracking: Please select your country in backoffice', 'gootracking-for-woocommerce' );
		}

	} else {
	echo __('Please install WooCommerce.', 'gootracking-for-woocommerce' );
	}	
	return ob_get_clean();
}


