<?php

if ( ! defined( 'ABSPATH' ) )
	exit;


Class gootracking_dashboardFeedbacks{
	function __construct(){

		$orders = get_posts(
			array(
				'posts_per_page'   => -1,
		    	'post_type'   => 'shop_order',
		    	'post_status' => array( 
		    		//'wc-processing', 
		    		'wc-completed'
		    	)
			) 
		);
		echo '<h3>';
		echo __( 'Last 5 Feedbacks', 'gootracking' ) ;
		echo'</h3>';
		foreach($orders as $orderPost) {
	     	$order_id = $orderPost->ID;
	     	$order = new WC_Order($order_id);
	     	$oWC_Order_Custom = new gootracking_WC_Order_Custom( $order_id );
	     	$arrayFeedback = $oWC_Order_Custom->getarrayFeedback();
	     	if(is_array($arrayFeedback)) {
		     	foreach($arrayFeedback as $question) {
					echo '<p>';
						if( $question['nameQuestion'] == 'satisfiedReparationRate') {
							echo __( 'Order:', 'gootracking' ) ;
							echo '<a href="' . admin_url(). '/post.php?post='. $order_id . '&action=edit">';
								echo $order_id;     	
							echo '</a>';
							echo ' ';
							echo  __( 'Rate: ', 'gootracking' ). $question['answerQuestion'];
						}
						//echo $question['nameQuestion'];
					echo '</p>';
				}
			}
	    }

		$orders = get_posts(
			array(
				'posts_per_page'   => -1,
		    	'post_type'   => 'shop_order',
		    	'post_status' => array( 
		    		'wc-completed'
		    	)
			) 
		);		
		$countOrdersWithFeedbackRequest = 0;
		$countOrdersWithFeedback = 0;
		$countOrdersFirstShippingOrder = 0;
		foreach($orders as $orderPost) {
	     	$order_id = $orderPost->ID;
	     	$oWC_Order_Custom = new gootracking_WC_Order_Custom( $order_id );
	     	if($oWC_Order_Custom->isFirstShippingOrder() == true ) {
	     		$countOrdersFirstShippingOrder++;		     	
		     	if($oWC_Order_Custom->getarrayHistoricalFeedbackRequest() != '' ) 
		     		$countOrdersWithFeedbackRequest++;
		     	if($oWC_Order_Custom->getarrayFeedback() != '' )
		     		$countOrdersWithFeedback++;
		     }

	    }
	    
	    
	    echo $countOrdersWithFeedback .'/'. $countOrdersFirstShippingOrder .' '. __('Completed orders from customer get feedback', 'gootracking-for-woocommerce' );
	    ?><br><?php
	    echo $countOrdersWithFeedbackRequest .'/'. $countOrdersFirstShippingOrder .' '. __('Completed orders from customer get feedback request', 'gootracking-for-woocommerce' );
		//wp_mail( 'sternwebagency@gmail.com', '[alan]', count($orders). 'orders/'. $countNoFeedback);	    
	    ?>
	    <form method="post">
	    	<button type="submit" name="requestFeedbacks" class="button button-primary calculate-tax-action"><?php _e('Request feedbacks', 'gootracking-for-woocommerce' ); ?></button>
	    </form>
	    <?php
	}
}
		
