<?php

if ( ! defined( 'ABSPATH' ) )
exit;


Class gootracking_template_workflow{
	function __construct( ){
		
		$blue = '#25C6DA';
		$actual_order_id = $_GET['post'];
		$oWC_Order_Custom = new gootracking_WC_Order_Custom($actual_order_id );
		if($oWC_Order_Custom->getshippingType() == 'quote' ) {
			$shipping_order_id = $oWC_Order_Custom->getparentOrder();
			$returnToFinalCust_id = (new gootracking_WC_Order_Custom($shipping_order_id ))->getorderIdRetrunToFinalCust();
			$quote_order_id = $actual_order_id ;
			$colorIconShipment = "#444444";
			$colorIconQuote = $blue;
			$colorIconReturnFinalCust = "#444444";
		} else if($oWC_Order_Custom->getshippingType() == 'returnToFinalCust' ) {
			$shipping_order_id = $oWC_Order_Custom->getparentOrder();
			$returnToFinalCust_id = $actual_order_id;
			$quote_order_id = (new gootracking_WC_Order_Custom($shipping_order_id ))->getlinkedOrder();
			$colorIconShipment = "#444444";
			$colorIconQuote = "#444444";
			$colorIconReturnFinalCust = $blue;				
		} else {
			$shipping_order_id = $actual_order_id;
			$quote_order_id = $oWC_Order_Custom->getlinkedOrder();
			$returnToFinalCust_id = $oWC_Order_Custom->getorderIdRetrunToFinalCust();
			$colorIconShipment = $blue;
			$colorIconQuote = "#444444";
			$colorIconReturnFinalCust = "#444444";				
		}
		
	
	?>
		
	
		<form method="post"></form>

		<div class="WorkflowData">
			<?php
				$oWorkflowTemplate = new gootracking_WorkflowTemplate();
				$oWorkflowTemplate->order_id = $shipping_order_id;
				$oWorkflowTemplate->shipping_order_id = $shipping_order_id;
				$oWorkflowTemplate->colorIcon = $colorIconShipment;
				$oWorkflowTemplate->nameClass = "Shipment"; 
				$oWorkflowTemplate->title = __('Shipping Order', 'gootracking-for-woocommerce' );
				$oWorkflowTemplate->dashiconsName = "dashicons dashicons-email-alt";
				$oWorkflowTemplate->hiddenInput = "shipping_order_id";
				$oWorkflowTemplate->newOrderType = "";
				$oWorkflowTemplate->gootracking_showIconWorkflow();
				//new gootracking_showIconWorkflow($order_id, $colorIcon, $blue, $title, $dashiconsName, $hiddenInput, $nameClass, $actual_order_id, $shipping_order_id, $returnToFinalCust_id, $quote_order_id, $newOrderType);
			?>			
			<?php $oWorkflowTemplate->gootracking_showArrowTemplate();	?>

			<?php
				$oWorkflowTemplate = new gootracking_WorkflowTemplate();
				$oWorkflowTemplate->order_id = $quote_order_id;
				$oWorkflowTemplate->shipping_order_id = $shipping_order_id;
				$oWorkflowTemplate->colorIcon = $colorIconQuote;
				$oWorkflowTemplate->nameClass = "Quote"; 
				$oWorkflowTemplate->title = __('Quote', 'gootracking-for-woocommerce' );				
				$oWorkflowTemplate->dashiconsName = "dashicons dashicons-admin-tools";
				$oWorkflowTemplate->hiddenInput = "quote_order_id";
				$oWorkflowTemplate->newOrderType = "quote";
				$oWorkflowTemplate->gootracking_showIconWorkflow();
				//new gootracking_showIconWorkflow($order_id, $colorIcon, $blue, $title, $dashiconsName, $hiddenInput, $nameClass, $actual_order_id, $shipping_order_id, $returnToFinalCust_id, $quote_order_id, $newOrderType);
			?>				
		

			<?php $oWorkflowTemplate->gootracking_showArrowTemplate();	?>

			<?php
				$oWorkflowTemplate = new gootracking_WorkflowTemplate();
				$oWorkflowTemplate->order_id = $returnToFinalCust_id;
				$oWorkflowTemplate->shipping_order_id = $shipping_order_id;
				$oWorkflowTemplate->colorIcon = $colorIconReturnFinalCust;
				$oWorkflowTemplate->nameClass = "ReturnToFinalCust";
				$oWorkflowTemplate->title = __('Order Retrun to Cust', 'gootracking-for-woocommerce' );
				$oWorkflowTemplate->dashiconsName = "dashicons dashicons-share-alt2";
				$oWorkflowTemplate->hiddenInput = "returnToFinalCust_id";
				$oWorkflowTemplate->newOrderType = "returnToFinalCust";
				$oWorkflowTemplate->gootracking_showIconWorkflow();
				//new gootracking_showIconWorkflow($order_id, $colorIcon, $blue, $title, $dashiconsName, $hiddenInput, $nameClass, $actual_order_id, $shipping_order_id, $returnToFinalCust_id, $quote_order_id, $newOrderType);
				
			?>
							
		</div>


		<br>
	<?php
	}
}



Class gootracking_WorkflowTemplate{
	public $order_id;
	public $shipping_order_id;
	public $colorIcon;
	public $nameClass; 
	public $title;
	public $dashiconsName;
	public $hiddenInput;
	public $newOrderType;
	public $order;
	public $shippingType;

	function __construct(){}
	function gootracking_showIconWorkflow(){	

		?>
		
			<div class="<?php echo $this->nameClass; ?>">
				<?php if(($this->order_id =="" || get_post_status( $this->order_id ) == 'trash' )) : ?>
					<?php $this->colorIcon = "#878787"; ?>
				<?php endif; ?>	

				<?php if(!($this->order_id =="" || get_post_status( $this->order_id ) == 'trash' || $this->colorIcon == $this->blue)) :?>
					<a href="<?php echo get_edit_post_link($this->order_id); ?>">					
				<?php endif; ?>					
						<span title="<?php echo $this->title; ?>" style="color:<?php echo $this->colorIcon ?>;" class="<?php echo $this->dashiconsName; ?>" id="styleDashiconsorderType"></span>
					</a>
				<?php 
				$this->gootracking_showActionWorkflow();
				?>				
			</div>			
		<?php
	}	
	function gootracking_showActionWorkflow(){
		$oWC_Order_Custom = new gootracking_WC_Order_Custom($this->order_id );
		$this->shippingType = $oWC_Order_Custom->getshippingType();

		?>
		<h4>
			<?php echo $this->title; ?>
		</h4>






		<?php 
		$post = $_GET["post"];
		if($post == ''){
			$this->showCheckboxToDetermineShippingType();

		} else {
		
			if($this->order_id =="" || get_post_status( $this->order_id ) == 'trash') {
				$this->showNewOrderButton();
			} else {
				$this->showDetailsOrder();
			}
		}		
	}
	function showDetailsOrder() {
		
		$this->order = new WC_Order( $this->order_id );							
		//$key = __('New Order Retrun To Final Cust', 'gootracking-for-woocommerce' );
		$value = __('Order ID:', 'gootracking'). " <a href=". get_edit_post_link($this->order_id) .">" . $this->order_id . "</a>";
		$price = __('Price:', 'gootracking')." ".$this->order->get_formatted_order_total()  ;
		echo '<p>'.$value.'</p>';
		echo '<p>'.$price.'</p>';
		
		echo '<p>'.wc_get_order_status_name($this->order->get_status( )).'</p>';
		$this->showTerminateOrderButton();
		
	}	



	function showCheckboxToDetermineShippingType(){
		?>
													
			<br>
			<input type="hidden" name="shipping_order_id" value="<?php echo $this->shipping_order_id; ?>">
			<input type="radio" id="shippingType" name="shippingType" value="<?php echo $this->newOrderType; ?>">

			
		<?php			
	}


	function showNewOrderButton(){
			?>
			<form name="<?php echo $this->newOrderType; ?>" method="post">										
				<br>
				<input type="hidden" name="shipping_order_id" value="<?php echo $this->shipping_order_id; ?>">
			<?php if(false) : ?>
				<input type="hidden" name="actual_order_id" value="<?php echo $this->actual_order_id; ?>">
				<input type="hidden" name="returnToFinalCust_id" value="<?php echo $this->returnToFinalCust_id; ?>">
				<input type="hidden" name="quote_order_id" value="<?php echo $this->quote_order_id; ?>">
			<?php endif; ?>
				
				<button type="submit" title="<?php _e('New order', 'gootracking-for-woocommerce' ); ?>" name="<?php echo $this->newOrderType; ?>" id="<?php echo $this->newOrderType; ?>" value="<?php echo $this->newOrderType; ?>" type="button">+</button>
			</form>
			<?php		
	}

	function showTerminateOrderButton(){
		if($this->order->get_status() != 'completed') {
			?>
				<form method="post">	
					<input type="hidden" name="<?php echo $this->hiddenInput; ?>" value="<?php echo $this->order_id; ?>">
					<button type="submit" title="<?php _e('terminate', 'gootracking-for-woocommerce' ); ?>" name="completeOrderType" id="completeOrderType" value="completeOrderType" type="button">&#10003;</button>
				</form>
			<?php
		}		
	}


	function gootracking_showArrowTemplate(){

			?>
				<div class="Arrow">
					<br><br>
					<span class="dashicons dashicons-arrow-right-alt" id="styleDashiconsArrow"></span>
				</div>		
			<?php
		
	}

}




