<?php
if ( ! defined( 'ABSPATH' ) )
	exit;


Class gootracking_rejectOrderByCust{
	function __construct($order_id){
	

		$order = new WC_Order($order_id);
		$oWC_Order_Custom = new gootracking_WC_Order_Custom( $order_id );

		if ( $oWC_Order_Custom->getshippingType() != 'quote' || $order->get_status() == 'failed') {
			return;
		}
		?>
			<div>
				<h2><?php _e('Reject Order', 'gootracking-for-woocommerce' ); ?></h2>
				<form method="post">	
					<input type="hidden" name="order_id" value="<?php echo $order_id; ?>">
					<textarea class="form-control" rows="5" placeholder="<?php _e('Reason for rejection', 'gootracking-for-woocommerce' ); ?>"  name="reasonRejectOrderByCust"></textarea>
					<button type="submit" name="rejectOrderByCust" class="button button-primary calculate-tax-action"><?php _e('Reject Quote', 'gootracking-for-woocommerce' ); ?></button>
				</form>
				<br>
				<br>
				<br>
				<br>
			</div>
			
		<?php
	}
}