<?php
if ( ! defined( 'ABSPATH' ) )
	exit;

Class gootracking_productUPS{
	function __construct($oWC_Order_Custom){
			
		//var_dump($oWC_Order_Custom);

		if($oWC_Order_Custom==null) {
			$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
		}
		if(is_object($oWC_Order_Custom)) {
			$comment = $oWC_Order_Custom->getcomment();
			$itemWeight = $oWC_Order_Custom->getitemWeight();
			$itemLength = $oWC_Order_Custom->getitemLength();
			$itemWidth = $oWC_Order_Custom->getitemWidth();
			$itemHeight = $oWC_Order_Custom->getitemHeight();			
		} else {
			$itemWeight="";
			$itemLength="";
			$itemWidth="";
			$itemHeight="";		
			$comment="";			
		}		
	
	?>
			

	<div class="row" style="margin-top: 15px;">
	
		<div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
			<?php if(get_option("gootracking_ask_UPS_dimensions_item")!="false") : ?>
				<h4>
					<?php			
					 _e('Your Item', 'gootracking-for-woocommerce' );
					?>
				</h4>
					<div  style="height:30px;padding-top: 15px;">
						<span id="ajaxLoader"></span>
					</div>			
					<label for="itemWeight"><?php _e('itemWeight', 'gootracking-for-woocommerce' ); ?></label>
					<div class="form-group">
						<input type="number" min="0" step="1" value="<?php echo $itemWeight; ?>" class="form-control" name="itemWeight" id="itemWeight" placeholder="<?php _e('itemWeight', 'gootracking-for-woocommerce' ); ?>">
					</div>
					<label for="itemLength"><?php _e('dimensions', 'gootracking-for-woocommerce' ); ?></label>
					<div class="form-inline">
						<div class="form-group">
							<input type="number" min="0" step="1" value="<?php echo $itemLength; ?>" class="form-control" name="itemLength" id="itemLength" placeholder="<?php _e('itemLength', 'gootracking-for-woocommerce' ); ?>">
							<input type="number" min="0" step="1" value="<?php echo $itemWidth; ?>"class="form-control" name="itemWidth" id="itemWidth" placeholder="<?php _e('itemWidth', 'gootracking-for-woocommerce' ); ?>">
							<input type="number" min="0" step="1" value="<?php echo $itemHeight; ?>"class="form-control" name="itemHeight" id="itemHeight" placeholder="<?php _e('itemHeight', 'gootracking-for-woocommerce' ); ?>">
						</div>
					</div>					
					
			<?php endif; ?>
				
			<br>
			<?php new gootracking_productDetailsTemplate($oWC_Order_Custom); ?>
			
			
			
		</div>
	</div>
	
	<?php
			
	}
}