<?php

if ( ! defined( 'ABSPATH' ) )
	exit;



class gootracking_WC_Order_Custom_UPS extends gootracking_WC_Order_Custom {
	
	protected $isPickupClient;
	protected $itemWeight;
	protected $itemLength;
	protected $itemHeight;
	protected $itemWidth;
	
	protected $address_AddressLine;
	protected $address_City;
	protected $address_PostalCode;
	protected $address_CountryCode;
	
	
	protected $CloseTime;
	protected $ReadyTime;
	protected $PickupDate;
	protected $CompanyName;
	protected $ContactName;
	protected $SpecialInstruction;
	protected $IdPDFPickupClient;
	
	protected $unit_Code;
	protected $unitWeight;	
	protected $phone_Number;
	protected $phone_Extension;


	
	
	
	public function __construct( $id = '' ) {
		if($id != null){		
			parent::__construct( $id  );			
			$this->isPickupClient = get_post_meta( $id, '_'.'isPickupClient', true);
			$this->itemWeight = get_post_meta( $id, '_'.'itemWeight',true );			
			$this->itemLength = get_post_meta( $id, '_'.'itemLength',true );
			$this->itemHeight = get_post_meta( $id, '_'.'itemHeight',true );
			$this->itemWidth = get_post_meta( $id, '_'.'itemWidth',true );
			
			$this->address_AddressLine = get_post_meta( $id, '_'.'address_AddressLine',true );
			$this->address_City = get_post_meta( $id, '_'.'address_City',true );
			$this->address_PostalCode = get_post_meta( $id, '_'.'address_PostalCode',true );
			$this->address_CountryCode = get_post_meta( $id, '_'.'address_CountryCode',true );
			
			$this->CloseTime = get_post_meta( $id, '_'.'CloseTime',true );
			$this->ReadyTime = get_post_meta( $id, '_'.'ReadyTime',true );
			$this->PickupDate = get_post_meta( $id, '_'.'PickupDate',true );
			$this->CompanyName = get_post_meta( $id, '_'.'CompanyName',true );
			$this->ContactName = get_post_meta( $id, '_'.'ContactName',true );
			$this->SpecialInstruction = get_post_meta( $id, '_'.'SpecialInstruction',true );
			$this->IdPDFPickupClient = get_post_meta( $id, '_'.'IdPDFPickupClient',true );
			
			$this->unit_Code = get_post_meta( $id, '_'.'unit_Code',true );
			$this->unitWeight = get_post_meta( $id, '_'.'unitWeight',true );
			$this->phone_Number = get_post_meta( $id, '_'.'phone_Number',true );
			$this->phone_Extension = get_post_meta( $id, '_'.'phone_Extension',true );
			

		}		
	}
	


	
	function getisPickupClient(){                   				return $this->isPickupClient; }
	function getitemWeight(){										return($this->itemWeight=="") ?  1 : $this->itemWeight; }
	function getitemLength(){                   					return($this->itemLength=="") ?  1 : $this->itemLength; }
	function getitemHeight(){                   					return($this->itemHeight=="") ?  1 : $this->itemHeight; }
	function getitemWidth(){                   						return($this->itemWidth=="") ?  1 : $this->itemWidth; }

	function getaddress_AddressLine(){                   			return $this->address_AddressLine; }
	function getaddress_City(){                   					return $this->address_City; }
	function getaddress_PostalCode(){                   			return $this->address_PostalCode; }
	function getaddress_CountryCode(){                   			return $this->address_CountryCode; }
	
	function getCloseTime(){      		             				return $this->CloseTime; }
	function getReadyTime(){      		             				return $this->ReadyTime; }
	function getPickupDate(){      		             				return $this->PickupDate; }
	function getCompanyName(){      		             			return $this->CompanyName; }
	function getContactName(){      		             			return $this->ContactName; }
	function getSpecialInstruction(){      		             		return $this->SpecialInstruction; }
	function getIdPDFPickupClient(){      		          	 		return $this->IdPDFPickupClient; }

	function getunit_Code(){                   						return $this->unit_Code; }
	function getunitWeight(){         								return $this->unitWeight; }
	function getphone_Number(){                 	  				return $this->phone_Number; }
	function getphone_Extension(){                  	 			return $this->phone_Extension; }


	
	
	function setisPickupClient($isPickupClient) {					$this->isPickupClient = $isPickupClient; }
	function setitemWeight($itemWeight) {							$this->itemWeight = $itemWeight; }	
	function setitemLength($itemLength) {							$this->itemLength = $itemLength; }
	function setitemHeight($itemHeight) {							$this->itemHeight = $itemHeight; }
	function setitemWidth($itemWidth) {								$this->itemWidth = $itemWidth; }

	function setaddress_AddressLine($address_AddressLine) {			$this->address_AddressLine = $address_AddressLine; }
	function setaddress_City($address_City) {						$this->address_City = $address_City; }
	function setaddress_PostalCode($address_PostalCode) {			$this->address_PostalCode = $address_PostalCode; }
	function setaddress_CountryCode($address_CountryCode) {			$this->address_CountryCode = $address_CountryCode; }
	

	function setCompanyName($CompanyName) {							$this->CompanyName = $CompanyName; }
	function setContactName($ContactName) {							$this->ContactName = $ContactName; }
	function setSpecialInstruction($SpecialInstruction) {			$this->SpecialInstruction = $SpecialInstruction; }
	function setIdPDFPickupClient($IdPDFPickupClient) {				$this->IdPDFPickupClient = $IdPDFPickupClient; }
	
	function setunit_Code($unit_Code) {								$this->unit_Code = $unit_Code; }
	function setunitWeight($unitWeight) {							$this->unitWeight = $unitWeight; }
	function setphone_Number($phone_Number) {						$this->phone_Number = $phone_Number; }
	function setphone_Extension($phone_Extension) {					$this->phone_Extension = $phone_Extension; }


	
	
	function setCloseTime($CloseTime) {
		/*
		if(!is_int($CloseTime)) {
			throw new Exception( '<strong>' .  __('CloseTime is not a number', 'gootracking' )  . '</strong> '  . $CloseTime  );			
		}*/
		
		if($CloseTime>2400) {
			throw new Exception( '<strong>' .  __('CloseTime is not correct', 'gootracking' )  . '</strong> '  . $CloseTime  );			
		}		
		$this->CloseTime = $CloseTime;			
	}
	function setReadyTime($ReadyTime) {
		/*
		if(!is_int($ReadyTime)) {
			throw new Exception( '<strong>' .  __('ReadyTime is not a number', 'gootracking' )  . '</strong> '  . $ReadyTime  );			
		}*/
		if($ReadyTime>2400) {
			throw new Exception( '<strong>' .  __('ReadyTime is not correct', 'gootracking' )  . '</strong> '  . $ReadyTime  );			
		}				
		$this->ReadyTime = $ReadyTime;
	}

	
	function setPickupDate($PickupDate) {
		$year = substr($PickupDate,0,4);
		$month = substr($PickupDate,4,2);
		$day = substr($PickupDate,6,2);
		if(checkdate ( $month , $day , $year )) {
			$this->PickupDate = $PickupDate; 
		} else {
			throw new Exception( '<strong>' .  __('Format of the date is not correct', 'gootracking' )  . '</strong> '  . $PickupDate  );
		}
		
	}
	
	
	
	function save(){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}

		$order_id = $this->id;
		parent::save();
		update_post_meta($order_id, '_'.'isPickupClient', $this->isPickupClient );
		update_post_meta($order_id, '_'.'itemWeight', $this->itemWeight );		
		update_post_meta($order_id, '_'.'itemLength', $this->itemLength );
		update_post_meta($order_id, '_'.'itemHeight', $this->itemHeight );
		update_post_meta($order_id, '_'.'itemWidth', $this->itemWidth );

		update_post_meta($order_id, '_'.'address_AddressLine', $this->address_AddressLine );
		update_post_meta($order_id, '_'.'address_City', $this->address_City );
		update_post_meta($order_id, '_'.'address_PostalCode', $this->address_PostalCode );
		update_post_meta($order_id, '_'.'address_CountryCode', $this->address_CountryCode );
			
		
		update_post_meta($order_id, '_'.'CloseTime', $this->CloseTime );
		update_post_meta($order_id, '_'.'ReadyTime', $this->ReadyTime );
		update_post_meta($order_id, '_'.'PickupDate', $this->PickupDate );
		update_post_meta($order_id, '_'.'CompanyName', $this->CompanyName );
		update_post_meta($order_id, '_'.'ContactName', $this->ContactName );
		update_post_meta($order_id, '_'.'SpecialInstruction', $this->SpecialInstruction );
		update_post_meta($order_id, '_'.'IdPDFPickupClient', $this->IdPDFPickupClient );
		
		update_post_meta($order_id, '_'.'unit_Code', $this->unit_Code );
		update_post_meta($order_id, '_'.'unitWeight', $this->unitWeight );
		update_post_meta($order_id, '_'.'phone_Number', $this->phone_Number );
		update_post_meta($order_id, '_'.'phone_Extension', $this->phone_Extension );
	

		return $order_id;

	
	}

	
	function getarrayoWC_Order_Custom_UPS_pickup() {
		$IdPDFPickupClient = $this->IdPDFPickupClient;
		$opdfUPS = new gootracking_pdfUPS($IdPDFPickupClient );
		$PRN = $opdfUPS->getPRN();
		$RateStatus = $opdfUPS->getRateStatus();
		$resp = $opdfUPS->getresp();
					
		$arrayoWC_Order_Custom = array (			
			__('address_AddressLine', 'gootracking') 		=> $this->address_AddressLine,	
			__('address_City', 'gootracking') 				=> $this->address_City,	
			__('address_PostalCode', 'gootracking') 		=> $this->address_PostalCode,	
			__('address_CountryCode', 'gootracking')		=> $this->address_CountryCode,	
			__('phone_Extension', 'gootracking') 			=> $this->phone_Extension,	
			__('phone_Number', 'gootracking') 				=> $this->phone_Number,	
			__('CloseTime', 'gootracking') 					=> $this->CloseTime,
			__('ReadyTime', 'gootracking') 					=> $this->ReadyTime,
			__('PickupDate', 'gootracking') 				=> $this->PickupDate,
			__('CompanyName', 'gootracking')				=> $this->CompanyName,
			__('ContactName', 'gootracking') 				=> $this->ContactName,
			__('SpecialInstruction', 'gootracking') 		=> $this->SpecialInstruction,
		);
		$arrayoWC_Order_Custom[__('PRN', 'gootracking')] = $PRN;
		
		if(get_option("gootracking_debug") == "true") {			
			$arrayoWC_Order_Custom[__('resp', 'gootracking')] = json_encode($resp);
		}
		
		return $arrayoWC_Order_Custom;
	}


}
	