<?php

if ( ! defined( 'ABSPATH' ) )
	exit;


	
class gootracking_pdfUPS {
		protected $id;
		protected $typePDF;
		protected $order_id;
		protected $pathFile;
		protected $baseURL;
		protected $idOrderUPS;
		protected $URLAPI;
		protected $resp;
		protected $RateStatus;
		protected $PRN;

	/**
	 * Constructor
	 */
	public function __construct($id = null) {
		if($id != null){			
			$this->id = $id;
			$this->typePDF = get_post_meta( $id, '_'.'typePDF',true );
			$this->order_id = get_post_meta( $id, '_'.'order_id',true );
			$this->pathFile = get_post_meta( $id, '_'.'pathFile',true ); 
			$this->baseURL = get_post_meta( $id, '_'.'baseURL',true ); 
			$this->idOrderUPS = get_post_meta( $id, '_'.'idOrderUPS',true ); 
			$this->URLAPI = get_post_meta( $id, '_'.'URLAPI',true ); 
			$this->resp = get_post_meta( $id, '_'.'resp',true ); 
			$this->PRN = get_post_meta( $id, '_'.'PRN',true );
			$this->RateStatus = get_post_meta( $id, '_'.'RateStatus',true );
			
			

		}
	}
	
	
	function getid(){                   				return $this->id; }
	function gettypePDF(){                   			return $this->typePDF; }
	function getorder_id(){                   			return $this->order_id; }
	function getpathFile(){                   			return $this->pathFile; }
	function getbaseURL(){                   			return $this->baseURL; }
	function getidOrderUPS(){                   		return $this->idOrderUPS; }
	function getURLAPI(){            		       		return $this->URLAPI; }
	function getresp(){            		      			return $this->resp; }
	function getPRN(){                   				return $this->PRN; }
	function getRateStatus(){                   		return $this->RateStatus; }
	

	function setid($id) {											$this->id = $id; }
	function settypePDF($typePDF) {									$this->typePDF = $typePDF; }
	function setorder_id($order_id) {								$this->order_id = $order_id; }
	function setpathFile($pathFile) {								$this->pathFile = $pathFile; }
	function setbaseURL($baseURL) {									$this->baseURL = $baseURL; }
	function setidOrderUPS($idOrderUPS) {							$this->idOrderUPS = $idOrderUPS; }
	function setresp($idOrderUPS) {									$this->resp = $resp; }
	
	
	function setRateStatus() {
		$resp = $this->resp;
		$RateStatus = $resp->RateStatus->Description;
		$this->RateStatus = $RateStatus; 
	}	

	function setPRN() {
		
		$resp = $this->resp;
		$PRN = $resp->PRN;
		$this->PRN = $PRN ;
		
	}	

	function save(){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}

		
		$post = array(
			'post_author' => $userID,
			'post_content' => '',
			'post_status' => 'publish',
			'post_title' => $_GET["blogname"],
			'post_type' => 'pdfUPS',
		);		
		if($this->id != null){ 
			$post['ID'] = $this->id ;
		}

		$post_id = wp_insert_post( $post );	
		update_post_meta($post_id , '_'.'typePDF' , $this->typePDF );	
		update_post_meta($post_id , '_'.'order_id' , $this->order_id );	
		update_post_meta($post_id , '_'.'pathFile' , $this->pathFile);
		update_post_meta($post_id , '_'.'baseURL' , $this->baseURL);
		update_post_meta($post_id , '_'.'idOrderUPS' , $this->idOrderUPS);
		update_post_meta($post_id , '_'.'URLAPI' , $this->URLAPI);
		update_post_meta($post_id , '_'.'resp' , $this->resp);
	//	update_post_meta($order_id , '_id_pdfUPS' , $post_id);
		update_post_meta($post_id, '_'.'PRN', $this->PRN );
		update_post_meta($post_id, '_'.'RateStatus', $this->RateStatus );	
		
		
		return $post_id;		
		
	
	}

			

	function delete() {
		if($this->id != null){
			wp_delete_post($this->id,true);
		}		
	}
	
	function setURL($filename) {
		$userID = get_current_user_id();
		$key = uniqid();
		$upload_dir = wp_upload_dir();
		$dir = $upload_dir['basedir'];
		$upsFolder = "/UPS";	
		$folder = $dir.$upsFolder;
		if (!file_exists($folder)) {
			mkdir ( $folder);
		}		
		$filename= $this->order_id ."_".$userID."_".$key."_".$filename;			
		$pathFile = $dir.$upsFolder."/".$filename;
		$baseURL = $upload_dir['baseurl'].$upsFolder."/".$filename;
		$this->pathFile = $pathFile;
		$this->baseURL = $baseURL;
		
	}
	function getURLAPIFormated(){
		$link;
		if(get_option("gootracking_debug") == "true") {
			$link = '<a href="' . $this->URLAPI . '">' . $this->id . '</a>';
		}
		return $link;
		
	}
	function showRespFormated(){
		
		if(get_option("gootracking_debug") == "true") {
			$return =  $this->resp ;
			var_dump( $return);
		}
		
		
	}	
	
	function setURLAPI($toCust=false) {		
		
		//if($this->order_id!="") {
			$order = new WC_Order( $this->order_id );				
		//	$name=$order->billing_first_name. " " . $order->billing_last_name;
		//	$address=$order->shipping_address_1. " " . $order->shipping_address_2;
			//$address=$order->shipping_address_1;
		//	$city = $order->shipping_city;
		//	$postcode = $order->shipping_postcode;
			
			
			$oWC_Order_Custom = new gootracking_WC_Order_Custom_UPS($this->order_id );

			//$itemWeight = ($oWC_Order_Custom->getitemWeight() =="") ? 1 : $oWC_Order_Custom->getitemWeight();
			
			/*		
		} else {
			$name= $_POST['billing_first_name'] . " " . $_POST['billing_last_name'];				
			//$address=$_POST['billing_address_1'] . " " . $_POST['billing_address_2'];
			//$address=$_POST['billing_address_1'] ;
			$city = $_POST['billing_city'];
			$postcode = $_POST['billing_postcode'];
					
			$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
			
	
					
			
		}
		*/
	//	$name= gootracking_URLReady($name);
	//	$address= gootracking_URLReady($address);
	//	$city = gootracking_URLReady($city);
	//	$postcode = gootracking_URLReady($postcode);
		
		if(get_option("gootracking_UPS_is_production") == "true") {
			$production = 1;
		} else {
			$production = 0;
		}				

		$uri ="";
		//$uri .= "http://gootracking.gooplus.fr/wp-admin/admin-ajax.php?action=gootracking_get_result_API_UPS";
		$uri .= (new gootracking_option)->getURL_server_API_admin_ajax();
		$uri .= "?action=gootracking_get_result_API_UPS";
		$uri .= "&production=" . $production;
		$uri .= "&mode=text";
		if($this->typePDF=="pdfUPS") {			
			$uri .= "&operation=ProcessShipment";
		} else if($this->typePDF=="pdfUPSPickupClient") {
			$uri .= "&operation=ProcessPickupCreation";
			$uri .= "&CloseTime=". $oWC_Order_Custom->getCloseTime();
			$uri .= "&ReadyTime=". $oWC_Order_Custom->getReadyTime();
			$uri .= "&PickupDate=". $oWC_Order_Custom->getPickupDate();
			$uri .= "&ContactName=". gootracking_URLReady($oWC_Order_Custom->getContactName());
			
			$uri .= "&SpecialInstruction=". gootracking_URLReady($oWC_Order_Custom->getSpecialInstruction());
				
			
			$IdPdfLabel = $oWC_Order_Custom->getIdPdfLabel();
			$opdfUPS = new gootracking_pdfUPS($IdPdfLabel); 	
			$idOrderUPS = $opdfUPS->getidOrderUPS();

		
			$uri .= "&ReferenceNumber=". $idOrderUPS;
			
		}
			
			
/*	
	protected $address_AddressLine;
	protected $address_City;
	protected $address_PostalCode;
	protected $address_CountryCode;
*/
/*
var_dump("aaaaaaaaaaa");
var_dump($oWC_Order_Custom);
var_dump("aaaaaaaaaaa");
var_dump($oWC_Order_Custom->getunit_Code());
*/
	
		$uri .= "&key="						. get_option('gootracking_key');
		
		$uri .= "&unit_Code=" 				. gootracking_URLReady($oWC_Order_Custom->getunit_Code());
		$uri .= "&unitWeight=" 				. gootracking_URLReady($oWC_Order_Custom->getunitWeight());
		
		$uri .= "&AccessLicenseNumber=" 	. gootracking_URLReadyCrypted(get_option('gootracking_AccessLicenseNumber'));
		$uri .= "&Username=" 				. gootracking_URLReadyCrypted(get_option('gootracking_Username'));
		$uri .= "&Password=" 				. gootracking_URLReadyCrypted(get_option('gootracking_Password'));
		$uri .= "&ShipperNumber=" 			. gootracking_URLReadyCrypted(get_option('gootracking_ShipperNumber'));
			
		$uri .= "&email="					. $order->billing_email;

		$uri .= "&dimensions_Length=" 		. $oWC_Order_Custom->getitemLength();
		$uri .= "&dimensions_Width=" 		. $oWC_Order_Custom->getitemWidth();
		$uri .= "&dimensions_Height=" 		. $oWC_Order_Custom->getitemHeight();
		$uri .= "&packageweight_Weight=" 	. $oWC_Order_Custom->getitemWeight();	
		
		
		if($toCust==false) {
			//FROM
			$uri .= "&CompanyName="				. gootracking_URLReady($oWC_Order_Custom->getCompanyName());
			$uri .= "&shipper_Name="			. gootracking_URLReady($oWC_Order_Custom->getContactName());;
			$uri .= "&address_AddressLine=" 	. gootracking_URLReady($oWC_Order_Custom->getaddress_AddressLine());
			$uri .= "&address_City="			. gootracking_URLReady($oWC_Order_Custom->getaddress_City());
			$uri .= "&address_PostalCode=" 		. gootracking_URLReady($oWC_Order_Custom->getaddress_PostalCode());
			$uri .= "&address_CountryCode=" 	. gootracking_URLReady($oWC_Order_Custom->getaddress_CountryCode());
			$uri .= "&phone_Number=" 			. gootracking_URLReady($oWC_Order_Custom->getphone_Number());
			$uri .= "&phone_Extension=" 		. gootracking_URLReady($oWC_Order_Custom->getphone_Extension());			
			//TO	
			$uri .= "&shipto_Name="				. gootracking_URLReady(get_option('gootracking_company_name'));
			$uri .= "&addressTo_AddressLine="	. gootracking_URLReady(get_option('gootracking_company_address'));
			$uri .= "&addressTo_City="			. gootracking_URLReady(get_option('gootracking_company_city'));
			$uri .= "&addressTo_PostalCode="	. gootracking_URLReady(get_option('gootracking_company_postalCode'));
			$uri .= "&addressTo_CountryCode="	. gootracking_URLReady(get_option('gootracking_company_country'));
			
		} else {
			//TO
			$uri .= "&CompanyName="				. gootracking_URLReady(get_option('gootracking_company_name'));
			$uri .= "&shipper_Name="			. gootracking_URLReady(get_option('gootracking_company_user_name'));
			$uri .= "&address_AddressLine=" 	. gootracking_URLReady(get_option('gootracking_company_address'));
			$uri .= "&address_City="			. gootracking_URLReady(get_option('gootracking_company_city'));
			$uri .= "&address_PostalCode=" 		. gootracking_URLReady(get_option('gootracking_company_postalCode'));
			$uri .= "&address_CountryCode=" 	. gootracking_URLReady(get_option('gootracking_company_country'));
			$uri .= "&phone_Number=" 			. gootracking_URLReady(get_option('gootracking_company_phone_Number'));
			$uri .= "&phone_Extension=" 		. gootracking_URLReady(get_option('gootracking_company_phone_Extension'));					
			//FROM		
			$uri .= "&shipto_Name="				. gootracking_URLReady($oWC_Order_Custom->getContactName());	
			$uri .= "&addressTo_AddressLine="	. gootracking_URLReady($oWC_Order_Custom->getaddress_AddressLine());	
			$uri .= "&addressTo_City="			. gootracking_URLReady($oWC_Order_Custom->getaddress_City());	
			$uri .= "&addressTo_PostalCode="	. gootracking_URLReady($oWC_Order_Custom->getaddress_PostalCode());	
			$uri .= "&addressTo_CountryCode="	. gootracking_URLReady($oWC_Order_Custom->getaddress_CountryCode());	
		}
	
		$this->URLAPI = $uri;
		//wp_mail( 'sternwebagency@gmail.com', '[alan]', 'Error desactivate. URL: '. $uri);
			
	}
	function statusUPSLabel() {
		$uri = $this->URLAPI;
		$resp = json_decode(wp_remote_fopen($uri));
		$status = $resp->Response->ResponseStatus->Description;
		
		$arrayStatus = array (
			'status' => $status ,
			'uri' => $uri,
			'resp' => $resp,
		);
		return $arrayStatus;
		
		
	}
	function saveUPSLabelToServer(){		
		$uri = $this->URLAPI;		
		$resp = $this->resp;
		
		$imageData = $resp->ShipmentResults->PackageResults->ShippingLabel->GraphicImage;
		$pathFileGIF = $this->pathFile.".gif";
		$imageData = base64_decode($imageData);
		$source = imagecreatefromstring($imageData);
	//	$rotate = imagerotate($source, $degrees, 0); // if want to rotate the image
		$imageSave = imagegif($source,$pathFileGIF,100);
		imagedestroy($source);
		

		$dest === 'F';
		$mpdf = new mpdf();
		$html='<img src="'.$pathFileGIF.'">';
		
		$mpdf->WriteHTML($html);
		$mpdf->Output( $this->pathFile, $dest );
		
		$idOrderUPS = $resp->ShipmentResults->PackageResults->TrackingNumber;
		$this->idOrderUPS = $idOrderUPS;
		
		
	}
	function getRespUPS(){		
		$uri = $this->URLAPI;	

		$resp_encode = wp_remote_fopen($uri);
		$resp = json_decode($resp_encode);
		$ResponseStatus = $resp->Response->ResponseStatus->Description;
		//var_dump($ResponseStatus);
		if($ResponseStatus!="Success") {
			//var_dump($resp);
			
			$errorDescription = $resp->detail->Errors->ErrorDetail->PrimaryErrorCode->Description;
			if(get_option("gootracking_debug") == "true") {
				$uriError = '<strong>' .  __( 'Error Here: ', 'gootracking' )  . '</strong> ' . $uri;
				$respError = '<strong>' .  __( 'Error UPS Pickup', 'gootracking' )  . '</strong> ' . $resp_encode;
				if(!is_admin()) {
					wc_add_notice( $uriError , 'error'  );
					wc_add_notice( $respError , 'error'  );
				} else {
					echo $uriError;
					echo $respError;
					return;

				}	
			}
			$this->resp = $resp_encode;
			
			$order = new WC_Order($this->order_id);
			$order->update_status('Failed', $errorDescription );
			
			throw new Exception( '<strong>' .  __('Error Pick Up Client UPS', 'gootracking' )  . '</strong> '  . $errorDescription  );


		} else {
			$this->resp = $resp;
			//return $resp;			
		}
	}		
	function savePDFCustomToServer(){		
		$dest === 'F';
		$mpdf = new mpdf();
		$html = gootracking_getHtmlPdf($this->order_id );
		//$html = gootracking_output_to_buffer();
		$mpdf->WriteHTML($html);
		$mpdf->Output( $this->pathFile, $dest );			
	}
	
	function saveKialaToServer() {
		$URLUPS_acces_point = gootracking_getURLUPS_acces_point($this->order_id );
		copy($URLUPS_acces_point, $this->pathFile);
		$opdf2text = new gootracking_pdf2text();
		$opdf2text->setFilename($this->baseURL);
		$opdf2text->decodePDF();
		$opdf2text->findidOrderUPSinPDF();
		$idOrderUPS = $opdf2text->output();
		$this->idOrderUPS = $idOrderUPS;
	}
	

	
}
	