<?php

if ( ! defined( 'ABSPATH' ) )
	exit;



class gootracking_remotekey{
	protected $id;
	protected $userID;
	protected $key;
	protected $cryptedKey;	
	protected $title;
	protected $dateBegin;
	protected $dateEnd;
	protected $isActive;
	protected $nbUPSCalled;
	protected $siteurl;
	protected $dateFirstInstallPlugin;
	protected $dateDesinstallPlugin;
	protected $admin_email;
	protected $version_plugin;
	protected $localeCountry;
	protected $customer_orders;
	

	
	
	
	
	
	
	public function __construct( $id = '' ) {
		if($id != null){		
			// parent::__construct( $id = '' );		
			
			$this->id = $id;
			$this->userID = get_post_meta( $id, 'userID',true );
			$this->key = get_post_meta( $id, 'key',true );
			$this->cryptedKey = get_post_meta( $id, 'cryptedKey',true );
			$this->dateBegin = get_post_meta( $id, 'dateBegin',true );
			$this->dateEnd = get_post_meta( $id, 'dateEnd',true );
			$this->title = get_the_title ( $id);
			$this->siteurl = get_post_meta( $id, 'siteurl',true );
			$this->dateFirstInstallPlugin = get_post_meta( $id, 'dateFirstInstallPlugin',true );
			$this->dateDesinstallPlugin = get_post_meta( $id, 'dateDesinstallPlugin',true );
			$this->admin_email = get_post_meta( $id, 'admin_email',true );
			$this->version_plugin = get_post_meta( $id, 'version_plugin',true );
			$this->localeCountry = get_post_meta( $id, 'localeCountry',true );
			$this->customer_orders = get_post_meta( $id, 'customer_orders',true );

			$dateBegin =  strtotime($this->dateBegin); 
			$dateEnd = strtotime($this->dateEnd); 

			$now =  time();
			if($dateBegin<$now && $now<$dateEnd) {
				$this->isActive = true;
			} else {
				$this->isActive = false;
			}
			$this->nbUPSCalled = get_post_meta( $id, 'nbUPSCalled',true );
		}		
	}
	

	
	
	function getid(){                   							return $this->id; }
	function getuserID(){                   						return $this->userID; }
	function getkey(){                   							return $this->key; }
	function getcryptedKey(){                   					return $this->cryptedKey; }	
	function getsiteurl(){                   						return $this->siteurl; }	
	function getdateFirstInstallPlugin(){                   		return $this->dateFirstInstallPlugin; }	
	function getdateDesinstallPlugin(){                   			return $this->dateDesinstallPlugin; }	
	function getdateBegin(){                   						return $this->dateBegin; }
	function getdateEnd(){                   						return $this->dateEnd; }
	function getisActive(){                   						return $this->isActive; }
	function getnbUPSCalled(){               		    			return $this->nbUPSCalled; }
	function gettitle(){               		    					return $this->title; }
	function getadmin_email(){               		    			return $this->admin_email; }
	function getversion_plugin(){                  					return $this->version_plugin; }
	function getlocaleCountry(){               		   				return $this->localeCountry; }
	function getcustomer_orders(){             	    				return $this->customer_orders; }
	

	
	
	function setid($id) {											$this->id = $id; }
	function setuserID($userID) {									$this->userID = $userID; }
	function setkey($key) {											$this->key = $key; }
	function setcryptedKey($key) {									$this->cryptedKey = $cryptedKey; }	
	function setsiteurl($siteurl) {							$this->siteurl = $siteurl; }	
	function setdateFirstInstallPlugin($dateFirstInstallPlugin) {	$this->dateFirstInstallPlugin = $dateFirstInstallPlugin; }	
	function setdateDesinstallPlugin($dateDesinstallPlugin) {			$this->dateDesinstallPlugin = $dateDesinstallPlugin; }	
	function setdateBegin($dateBegin) {								$this->dateBegin = $dateBegin; }
	function setdateEnd($dateEnd) {									$this->dateEnd = $dateEnd; }
	function setnbUPSCalled($nbUPSCalled) {							$this->nbUPSCalled = $nbUPSCalled; }
	function settitle($title) {										$this->title = $title; }
	function setadmin_email($admin_email) {							$this->admin_email = $admin_email; }
	function setversion_plugin($version_plugin) {					$this->version_plugin = $version_plugin; }
	function setlocaleCountry($localeCountry) {						$this->localeCountry = $localeCountry; }
	function setcustomer_orders($customer_orders) {					$this->customer_orders = $customer_orders; }


	function save(){
		$userID = 1;
		if(get_current_user_id()){
			$userID = get_current_user_id();
		}

		
		$post = array(
			'post_author' => $userID,
			'post_content' => '',
			'post_status' => 'publish',
			'post_title' => $this->title,
			'post_type' => 'gootracking_rkey',
		);		
		if($this->id != null){ 
			$post['ID'] = $this->id ;
		}

		$post_id = wp_insert_post( $post );	
		update_post_meta($post_id , 'key' , $this->key );
		update_post_meta($post_id , 'userID' , $userID);
		update_post_meta($post_id , 'cryptedKey' , $this->cryptedKey );		
		update_post_meta($post_id , 'siteurl' , $this->siteurl );
		update_post_meta($post_id , 'dateFirstInstallPlugin' , $this->dateFirstInstallPlugin );
		update_post_meta($post_id , 'dateDesinstallPlugin' , $this->dateDesinstallPlugin );
		update_post_meta($post_id , 'dateBegin' , $this->dateBegin );
		update_post_meta($post_id , 'dateEnd' , $this->dateEnd );
		update_post_meta($post_id , 'nbUPSCalled' , $this->nbUPSCalled );
		update_post_meta($post_id , 'admin_email' , $this->admin_email );
		update_post_meta($post_id , 'version_plugin' , $this->version_plugin );
		update_post_meta($post_id , 'localeCountry' , $this->localeCountry );
		update_post_meta($post_id , 'customer_orders' , $this->customer_orders );
		
		

		return $post_id;		
		
	}
	public static function getIdFromKey( $key ) {
		$args = array(
			'post_type' => 'gootracking_rkey',
			'nopaging' => true,
			'meta_query' => array(
				array(
					'key'     => 'key',
					'value'   => $key,
					'compare' => '=',
				),
				
			),			
		);
		$allPosts = get_posts( $args );		
		foreach ( $allPosts as $post ) {		 
			setup_postdata( $post );		
			return $post->ID;
		}
		return null;		
	}
	
	public static function getIdFromUserID( $userID ) {
		$args = array(
			'post_type' => 'gootracking_rkey',
			'nopaging' => true,
			'meta_query' => array(
				array(
					'key'     => 'userID',
					'value'   => $userID,
					'compare' => '=',
				),
				
			),			
		);
		$allPosts = get_posts( $args );		
		foreach ( $allPosts as $post ) {		 
			setup_postdata( $post );		
			return $post->ID;
		}
		return null;		
	}
	
	function delete() {
		if($this->id != null){
			wp_delete_post($this->id,true);
		}		
	}
	/*
	function isKeyActive() {

		$dateBegin =  strtotime($this->dateBegin); 
		$dateEnd = strtotime($this->dateEnd); 
		$now =  time();

		
		if($dateBegin<$now && $now<$dateEnd) {
			return true;
		} else {
			return false;
		}
	}
	*/
	function incrementUPS() {
		$this->nbUPSCalled = $this->nbUPSCalled +1;
	}
	
	function isKeyActiveClient() {
		
		$url = (new gootracking_option)->getURL_server_API_admin_ajax();	
		$url .="?action=gootracking_is_key_active&key=". $this->key;

		//$url ="http://gootracking.gooplus.fr/wp-admin/admin-ajax.php?action=is_key_active&key=". $key;
		//var_dump($url);
		$isKeyActiveClient = json_decode(wp_remote_fopen($url));
		if( isKeyActiveClient ) {
			update_option('gootracking_key_is_active', "true");
		} else {
			update_option('gootracking_key_is_active', "false");
			update_option("gootracking_option_use_UPS","false");
		}
		return $isKeyActiveClient;
	}
	
	function isKeyActiveClientHtmlImage() {
		$isKeyActiveClient = $this->isKeyActiveClient();
		$urlImgOk = (dirname(plugins_url("/", __FILE__))).'/assets/button_ok.png';
		$urlImgError = (dirname(plugins_url("/", __FILE__))).'/assets/b16x16_cancel.png';
		
		
			?>					
			<?php if ($isKeyActiveClient) : ?>
				<img src=<?php echo $urlImgOk; ?>> <?php _e('Ok!', 'gootracking-for-woocommerce' ); ?> 
			<?php else: ?>
				<img src=<?php echo $urlImgError; ?>> <?php _e('Wrong!', 'gootracking-for-woocommerce' ); ?> 
				<?php var_dump($key); ?>
			<?php endif; ?>	
	<?php						
	}
	
	public static function cryptData($data, $cryptedKey) {

		
		$cryptedKeyHexa = pack('H*', $cryptedKey);
		
	   # --- CHIFFREMENT ---

		# la clé devrait être un binaire aléatoire, utilisez la fonction scrypt, bcrypt
		# ou PBKDF2 pour convertir une chaîne de caractères en une clé.
		# La clé est spécifiée en utilisant une notation héxadécimale.
	  //  $cryptedKey = pack('H*', "bcb04b7e103a0cd8b54763051cef08bc55abe029fdebae5e1d417e2ffb2a00a3");
		
		# Montre la taille de la clé utilisée ; soit des clés sur 16, 24 ou 32 octets pour
		# AES-128, 192 et 256 respectivement.
	   // $key_size =  strlen($cryptedKey);
		//echo "Taille de la clé : " . $key_size . "\n";
		
	   // $data = "Cette chaîne de caractère a été chiffrée en AES-256 / CBC / ZeroBytePadding.";

		# Crée un IV aléatoire à utiliser avec l'encodage CBC
		$iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);
		$iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
		
		# Crée un texte cipher compatible avec AES (Rijndael block size = 128)
		# pour conserver le texte confidentiel.
		# Uniquement applicable pour les entrées encodées qui ne se terminent jamais
		# pas la valeur 00h (en raison de la suppression par défaut des zéros finaux)
		$ciphertext = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $cryptedKeyHexa,
									 $data, MCRYPT_MODE_CBC, $iv);

		# On ajoute le IV au début du texte chiffré pour le rendre disponible pour le déchiffrement
		$ciphertext = $iv . $ciphertext;
		
		# Encode le texte chiffré résultant pour qu'il puisse être représenté par une chaîne de caractères
		$ciphertext_base64 = base64_encode($ciphertext);

		//echo  $ciphertext_base64 . "\n";

		# === ATTENTION ===

		# Le texte chiffré résultant ne contient aucune intégrité ni d'authentification
		# et il n'est pas protégé contre des attaques de type "oracle padding".
		return $ciphertext_base64;
			
	}
	
	public static function decryptData($data, $cryptedKey) {
		# --- DECHIFFREMENT ---
		
		$ciphertext_base64 = str_replace(" ", "+", $data);
		$cryptedKeyHexa = pack('H*', $cryptedKey);
		$ciphertext_dec = base64_decode($ciphertext_base64);
		
		# Récupère le IV, iv_size doit avoir été créé en utilisant la fonction
		# mcrypt_get_iv_size()
		# Crée un IV aléatoire à utiliser avec l'encodage CBC
		$iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);
		//$iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
		
		$iv_dec = substr($ciphertext_dec, 0, $iv_size);
		
		# Récupère le texte du cipher (tout, sauf $iv_size du début)
		$ciphertext_dec = substr($ciphertext_dec, $iv_size);

		# On doit supprimer les caractères de valeur 00h de la fin du texte plein
		$plaintext_dec = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $cryptedKeyHexa,
										$ciphertext_dec, MCRYPT_MODE_CBC, $iv_dec);
		
		return  $plaintext_dec;
	}


	public static function getIdPersiteurl($siteurl) {
		$args = array(
			'post_type' => 'gootracking_rkey',
			'nopaging' => true,
			'meta_query' => array(
				array(
					'key'     => 'siteurl',
					'value'   => $siteurl,
					'compare' => '=',
				),
				
			),			
		);
		$allPosts = get_posts( $args );		
		foreach ( $allPosts as $post ) {		 
			setup_postdata( $post );		
			return $post->ID;
		}
		return null;
	}
}
	