<?php
// Creating the widget 
class gootracking_widget extends WP_Widget {

	function __construct() {
		parent::__construct(
			// Base ID of your widget
			'gootracking_widget', 

			// Widget name will appear in UI
			__('GooTracking widget', 'stern-taxi-fare-widget'), 

			// Widget description
			array( 'description' => __( 'GooTracking widget', 'stern-taxi-fare-widget' ), ) 
		);
	}

	// Creating widget front-end
	// This is where the action happens
	public function widget( $args, $instance ) {
		
			$title = apply_filters( 'widget_title', $instance['title'] );
			
			
			echo $args['before_widget'];
			if ( ! empty( $title ) ) {
				echo $args['before_title'] . $title . $args['after_title'];
			}
			
			$atts="";
			launchForm($atts);
				
			
		
	}
		
	// Widget Backend 
	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) && isset( $instance[ 'no_of_events' ] ) ) {
			$title = $instance[ 'title' ];
			$no_of_events = $instance[ 'no_of_events' ];
		}
		else {
			$title = __( 'Booking form', 'gootracking-for-woocommerce' );
			$no_of_events = 4;
		}
	// Widget admin form
	?>
	<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
	</p>

	<?php
	}
	
	// Updating widget replacing old instances with new
	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		
		return $instance;
	}
} // Class gootracking_widget ends here

// Register and load the widget
function gootracking_widget() {
	register_widget( 'gootracking_widget' );
}
add_action( 'widgets_init', 'gootracking_widget' );

