<?php

if ( ! defined( 'ABSPATH' ) )
	exit;


/**
 * Validate the custom field.
 */
add_action('woocommerce_checkout_process', 'my_custom_checkout_field_process',9); 
function my_custom_checkout_field_process() {
    $oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
	if(!gootracking_WC_Order_Custom::isSessionShippingType("UPS", $oWC_Order_Custom)){
		return;
	}


		
	if($oWC_Order_Custom->getisPickupClient()==true) {
		if ( ! $_POST['CloseTime'] ) {
			wc_add_notice( __( 'Please enter something into this CloseTime.' ), 'error' );
			return;
		} 
		if ( ! $_POST['ReadyTime'] ) {
			wc_add_notice( __( 'Please enter something into this ReadyTime.' ), 'error' );
			return;
		} 
		if ( ! $_POST['PickupDate'] ) {
			wc_add_notice( __( 'Please enter something into this PickupDate.' ), 'error' );
			return;
		}  
		if ( (int)$_POST['CloseTime'] < (int)$_POST['ReadyTime'] ) {
			wc_add_notice( __( 'Close time must be after ReadyTime' ), 'error' );
			return;				
		} 
		
		$oWC_Order_Custom->setCloseTime( $_POST['CloseTime']);
		$oWC_Order_Custom->setReadyTime( $_POST['ReadyTime']);
		$oWC_Order_Custom->setPickupDate( $_POST['PickupDate']);
	}
					
		//$oWC_Order_Custom = WC()->session->get( 'oWC_Order_Custom' );
	
	if(isset($_POST['useSameInfoASBilling'])) {
		//$oWC_Order_Custom->setaddress_AddressLine( $address=$_POST['billing_address_1'] . " " . $_POST['billing_address_2'] );
		$oWC_Order_Custom->setaddress_AddressLine( $_POST['billing_address_1'] . " " . $_POST['billing_address_2'] );
		$oWC_Order_Custom->setaddress_City( $_POST['billing_city']);
		$oWC_Order_Custom->setaddress_PostalCode( $_POST['billing_postcode']);
		$oWC_Order_Custom->setCompanyName( $_POST['billing_company']);
		$oWC_Order_Custom->setContactName( $_POST['billing_first_name'] . " " . $_POST['billing_last_name']);
		

		$oWC_Order_Custom->setphone_Number( $_POST['billing_phone']);	
		
		
	} else {
		if ( ! $_POST['address_AddressLine'] ) {
			wc_add_notice( __( 'Please enter something into address_AddressLine' ), 'error' );
			return;
		} 
		if ( ! $_POST['ContactName'] ) {
			wc_add_notice( __( 'Please enter something into this ContactName.' ), 'error' );
			return;
		}
		if ( ! $_POST['address_City'] ) {
			wc_add_notice( __( 'Please enter something into this address_City.' ), 'error' );
			return;
		}
		if ( ! $_POST['address_PostalCode'] ) {
			wc_add_notice( __( 'Please enter something into this address_PostalCode.' ), 'error' );
			return;
		}
		if ( ! $_POST['CompanyName'] ) {
			wc_add_notice( __( 'Please enter something into this CompanyName.' ), 'error' );
			return;
		}				
		$oWC_Order_Custom->setaddress_AddressLine( 				$_POST['address_AddressLine']);
		$oWC_Order_Custom->setaddress_City( 					$_POST['address_City']);
		$oWC_Order_Custom->setaddress_PostalCode( 				$_POST['address_PostalCode']);
		$oWC_Order_Custom->setCompanyName( 						$_POST['CompanyName']);
		$oWC_Order_Custom->setContactName( 						$_POST['ContactName']);
		$oWC_Order_Custom->setphone_Number( 					$_POST['phone_Number']);
		$oWC_Order_Custom->setphone_Extension( 					$_POST['phone_Extension']);	
		
	
	}

	$oWC_Order_Custom->setunit_Code( 'CM' );
	$oWC_Order_Custom->setunitWeight( 'KGS' );	

	$oWC_Order_Custom->setaddress_CountryCode( get_option('gootracking_company_country'));
	$oWC_Order_Custom->setSpecialInstruction( $_POST['SpecialInstruction']);
	WC()->session->set( 'oWC_Order_Custom' , $oWC_Order_Custom );	
	/*
	var_dump("chloe");
	var_dump(WC()->session);
	*/
	//wc_add_notice( __( 'Please enter something into this aaaaaaaaaaaaaaa.' ), 'error' );
}

/**
 * Save the order meta with field value
 */
add_action( 'woocommerce_checkout_update_order_meta', 'gootracking_my_custom_checkout_field_update_order_meta' );
 
function gootracking_my_custom_checkout_field_update_order_meta( $order_id ) {
    if ( ! empty( $_POST['CloseTime'] ) ) {
    //    update_post_meta( $order_id, 'CloseTime', sanitize_text_field( $_POST['CloseTime'] ) );
    }
}