<?php

if ( ! defined( 'ABSPATH' ) )
	exit;

 

add_action( 'woocommerce_email_before_order_table', 'gootracking_email_before_order_table', 10, 2 );
function gootracking_email_before_order_table( $order, $is_admin ) {
	$order_id = $order->id;
	$oShow_link_view_order = new gootracking_email( $order_id );
	$oShow_link_view_order->generateLink();
	$oShow_link_view_order->showLink();

	if( $order->get_status() == 'completed') {
		$oShow_link_view_order->settypeEmail( 'feedback' );
		$oShow_link_view_order->generateLink();
		$oShow_link_view_order->showLink();
	}

	
}

add_action( 'woocommerce_email_after_order_table', 'gootracking_add_link_back_to_order', 10, 2 );
function gootracking_add_link_back_to_order( $order, $is_admin ) {	
	//$oWC_Order_Custom = new gootracking_WC_Order_Custom($order->id);
	$oWC_Order_Custom = gootracking_WC_Order_Custom::getCorrectInstanceOf_WC_Order_Custom($order->id);
	new gootracking_checkoutLabel( $order->id, false );
	new gootracking_checkout( $oWC_Order_Custom, true, false, true, true );	
}

add_action( 'woocommerce_order_status_completed', 'gootracking_order_status_completed', 1, 3 );
function gootracking_order_status_completed( $order_id ) {
}