<?php



//  http://gootracking.gooplus.fr/wp-admin/admin-ajax.php?action=gootracking_send_info&
add_action("wp_ajax_gootracking_send_info", "gootracking_send_info");
add_action("wp_ajax_nopriv_gootracking_send_info", "gootracking_send_info");
function gootracking_send_info()
{
	




	$siteurl = $_GET["siteurl"];
	$title = $_GET["title"];
	$customer_orders = $_GET["customer_orders"];
	$localeCountry = $_GET["localeCountry"];
	$version_plugin = $_GET["version_plugin"];
	$admin_email = $_GET["admin_email"];
	$desactivate = $_GET["desactivate"];



	$dateFirstInstallPlugin = date( 'Y-m-d H:i:s' );
	$dateDesinstallPlugin = date( 'Y-m-d H:i:s' );
	$idRemoteKey = gootracking_remotekey::getIdPersiteurl($siteurl);


	if($idRemoteKey == '') {
		$oRemoteKey = new gootracking_remotekey();
		$oRemoteKey->setdateFirstInstallPlugin($dateFirstInstallPlugin);
		$oRemoteKey->settitle($title);
		$oRemoteKey->setadmin_email($admin_email);
		$oRemoteKey->setversion_plugin($version_plugin);
		$oRemoteKey->setlocaleCountry($localeCountry);
		$oRemoteKey->setcustomer_orders($customer_orders);	
		$oRemoteKey->setsiteurl($siteurl);		
	} else {
		$oRemoteKey = new gootracking_remotekey($idRemoteKey);
	
		if($desactivate=='true') {
			$oRemoteKey->setdateDesinstallPlugin($dateDesinstallPlugin);
		} else {		
			$oRemoteKey->setadmin_email($admin_email);
			$oRemoteKey->setversion_plugin($version_plugin);
			$oRemoteKey->setlocaleCountry($localeCountry);
			$oRemoteKey->setcustomer_orders($customer_orders);	
			$oRemoteKey->setsiteurl($siteurl);
			$oRemoteKey->setdateDesinstallPlugin('');
		}	
	}

	$oRemoteKey->save();

	echo json_encode(true);

	die();
}



//  http://gootracking.gooplus.fr/wp-admin/admin-ajax.php?action=gootracking_is_key_active&key=181
add_action("wp_ajax_gootracking_is_key_active", "gootracking_is_key_active");
add_action("wp_ajax_nopriv_gootracking_is_key_active", "gootracking_is_key_active");
function gootracking_is_key_active()
{


	if((new gootracking_option)->getisAllFree()) {
		echo json_encode(true);
		die();
	} else {
		if(isset($_GET["key"])) {
			$key = $_GET["key"];
			$id=gootracking_remotekey::getIdFromKey( $key );
			$oRemoteKey = new gootracking_remotekey( $id );

			if($oRemoteKey->getisActive()== true ) {
				if(isset($_GET["ShippingType"])) {	
					if($_GET["ShippingType"]== "UPS" ) {
						$oRemoteKey->incrementUPS();
						$oRemoteKey->save();					
					}
				}
				echo json_encode(true);
				die();
			}
		}
	}
	echo json_encode(false);
    die();
}




//  http://ups-acces-point.gooplus.fr/wp-admin/admin-ajax.php?action=gootracking_extractUserInfo
add_action("wp_ajax_gootracking_extractUserInfo", "gootracking_extractUserInfo");
//add_action("wp_ajax_nopriv_gootracking_extractUserInfo", "gootracking_extractUserInfo");
function gootracking_extractUserInfo(){
$args = array( 
	'meta_key' => 'billing_company',
	'meta_compare' => 'EXISTS' 
);

$user_query = new WP_User_Query( $args );
echo '<table style="width:100%">';

if ( ! empty( $user_query->results ) ) {
	?>
	<tr>
		<th>display_name</th>
		<th>user_email</th>
		<th>user_url</th>
		<th>billing_company</th>
		<th>billing_Phone</th>
	</tr>
	
	<?php
    foreach ( $user_query->results as $author ) {
    	if(get_the_author_meta( 'billing_company', $author->ID) !='') {
	        // Line below display the author data. 
	        // Use print_r($author); to display the complete author object.
	        echo '<tr>';
		  		echo '<td>';
		        echo $author->display_name;
		        echo '</td>';
		        echo '<td>';
		        echo $author->user_email;
		        echo '</td>';
		        echo '<td>';
		        echo $author->user_email;		        
		        echo '</td>';
		        
		        echo '<td>';
		        echo get_the_author_meta( 'billing_company', $author->ID);
		        echo '</td>';

		        echo '<td>';
		        echo get_the_author_meta( 'billing_phone', $author->ID);
		        echo '</td>';
	        echo '</tr>';

	    }
        
    }
	
}
echo '</table>';


	die();

}

//  http://gootracking.gooplus.fr/wp-admin/admin-ajax.php?action=gootracking_get_result_API_UPS
add_action("wp_ajax_gootracking_get_result_API_UPS", "gootracking_get_result_API_UPS");
add_action("wp_ajax_nopriv_gootracking_get_result_API_UPS", "gootracking_get_result_API_UPS");
function gootracking_get_result_API_UPS()
{


	$key = $_GET["key"];
	if(!(new gootracking_option)->getisAllFree()) {
		if(!isset($_GET["key"])) {
			echo __('No Key', 'gootracking-for-woocommerce' );
			die();
		}
		



		if($cryptedKey == null) {
			echo __('cryptedKey not valide', 'gootracking-for-woocommerce' );
			die();
		}		
	}
	
		$id=gootracking_remotekey::getIdFromKey( $key );
		$oRemoteKey = new gootracking_remotekey( $id );
		$cryptedKey = $oRemoteKey->getcryptedKey();


	$uri ="";
	$uri .= get_option('gootracking_URL_server_API');
	$uri .= "/SoapShipClient.php/?";
	foreach($_GET as $key => $value){
		if($key!="action") {
			if($key=="AccessLicenseNumber" || $key=="Username" || $key=="Password" || $key=="ShipperNumber") {
				
				$value_parsed = gootracking_remotekey::decryptData($value, $cryptedKey);
				$value_parsed = preg_replace("/[^a-zA-Z0-9]+/", "", $value_parsed);
				$value_parseda = urlencode($value_parsed);
				//echo $value_parsed."_";
				//echo $cryptedKey."__".$key ."__".$value. "__" . $value_parsed."\n";
				//$uri.= $key . "=" .  (str_replace('%00','',urlencode($value_parsed))) . "&";
				//$value_parsed = urlencode($value_parsed);
				//$uri.= $key . "=" .  (str_replace('%00','',urlencode($value_parsed))) . "&";
				//$value_parsed = preg_replace("/[^a-zA-Z0-9]+/", "", $value_parsed);
				/*
				$value_parsed = urlencode($value_parsed);
				$value_parsed = str_replace("%00", "", $value_parsed);
				$value_parsed = urlencode($value_parsed);
				$value_parsed = preg_replace("/[^a-zA-Z0-9]+/", "", $value_parsed);
				$value_parsed = urlencode($value_parsed);
				*/
				
				//$value_parsed = preg_replace( '/[^[:print:]]/', '',$value_parsed);
				$uri.= $key . "=" . $value_parseda . "&";
			} else {
				$uri.= $key . "=" . $value . "&";
			}
		}
	}

//	echo strlen ($test);
//	echo "alan";
//var_dump($uri);
	//echo ($uri);
	echo wp_remote_fopen($uri);
//echo fopen($uri, "r");
//var_dump( file_get_contents($uri));
//var_dump("http://vilma.fr/wp-content/plugins/gootracking_API/SoapShipClient.php/?production=0&mode=text&operation=ProcessShipment&key=demovrZ6_b1ZSc1F1dEoxa2c&unit_Code=CM&unitWeight=KGS&phone_Number=GootrackingPlusChar33652660533&phone_Extension=&AccessLicenseNumber=4D0970E1652524D5&Username=VILMAADM1&Password=647672&ShipperNumber=0A465E&CompanyName=sternwebagency&shipper_Name=AlanGootrackingSpaceCharSZTERNBERG&address_AddressLine=51GootrackingSpaceCharrueGootrackingSpaceCharAnatoleGootrackingSpaceCharfranceGootrackingSpaceChar&address_City=Levallois&address_PostalCode=92300&address_CountryCode=FR&shipto_Name=ALAN&addressTo_AddressLine=51GootrackingSpaceCharrueGootrackingSpaceCharAnatoleGootrackingSpaceCharfrance&addressTo_City=Levallois&addressTo_PostalCode=92300&addressTo_CountryCode=FR&email=alan345@gmail.com&dimensions_Length=1&dimensions_Width=1&dimensions_Height=1&packageweight_Weight=32&");
    die();
}


