<?php
if ( ! defined( 'ABSPATH' ) )
	exit;

Class gootracking_checkoutUPS {
	function __construct($checkout, $oWC_Order_Custom){
		if(!is_object ( $oWC_Order_Custom )) {
			return;
		}
		if(!gootracking_WC_Order_Custom::isSessionShippingType("UPS")){
			return;
		}
	
		
		
		echo '<div id="UPSinformationDiv"><h2>' . __('UPS information') . '</h2>';
			
			$checked = $checkout->get_value( 'useSameInfoASBilling' ) ? $checkout->get_value( 'useSameInfoASBilling' ) : 1;
			woocommerce_form_field( 'useSameInfoASBilling', array( 
			  'type' => 'checkbox', 
			  'class' => array('input-checkbox'), 
			  'label' => __('useSameInfoASBilling'), 
			  'required' => false,
			), $checked );	
			
			echo '<div id="addressUPS">';
				woocommerce_form_field( 'address_AddressLine', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('address_AddressLine'),
					'placeholder'   => __('address_AddressLine'),
					), $checkout->get_value( 'address_AddressLine' ));
				woocommerce_form_field( 'address_City', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('address_City'),
					'placeholder'   => __('address_City'),
					), $checkout->get_value( 'address_City' ));
					
				woocommerce_form_field( 'address_PostalCode', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('address_PostalCode'),
					'placeholder'   => __('address_PostalCode'),
					), $checkout->get_value( 'address_PostalCode' ));
					
		/*		woocommerce_form_field( 'address_CountryCode', array(
					'type'          => 'hidden',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('address_CountryCode'),
					'placeholder'   => __('address_CountryCode'),
					), $checkout->get_value( 'address_CountryCode' ));			
					*/
					

				
				
				woocommerce_form_field( 'CompanyName', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('CompanyName'),
					'placeholder'   => __('CompanyName'),
					), $checkout->get_value( 'CompanyName' ));
					
				woocommerce_form_field( 'ContactName', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('ContactName'),
					'placeholder'   => __('ContactName'),
					), $checkout->get_value( 'ContactName' ));
				woocommerce_form_field( 'phone_Number', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('phone_Number'),
					'placeholder'   => __('phone_Number'),
					), $checkout->get_value( 'phone_Number' ));
				woocommerce_form_field( 'phone_Extension', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('phone_Extension'),
					'placeholder'   => __('phone_Extension'),
					), $checkout->get_value( 'phone_Extension' ));					
			echo '</div>';
		
		
			woocommerce_form_field( 'SpecialInstruction', array(
				'type'          => 'textarea',
				'class'         => array('my-field-class form-row-wide'),
				'label'         => __('SpecialInstruction'),
				'placeholder'   => __('SpecialInstruction'),
				), $checkout->get_value( 'SpecialInstruction' ));
				
			if($oWC_Order_Custom->getisPickupClient()==true) {
				
							
				woocommerce_form_field( 'ReadyTime', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('ReadyTime: The time when your shipment(s) can be ready for UPS to pick up.'),
					'placeholder'   => __('ReadyTime HHMM'),
					), $checkout->get_value( 'ReadyTime' ));					
				woocommerce_form_field( 'CloseTime', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('CloseTime: The minimum amount of time UPS requires between customers request for a pickup and driver arriving at the location for the pickup'),
					'placeholder'   => __('CloseTime HHMM'),
					), $checkout->get_value( 'CloseTime' ));


				woocommerce_form_field( 'PickupDate', array(
					'type'          => 'text',
					'class'         => array('my-field-class form-row-wide'),
					'label'         => __('PickupDate YYYYMMDD'),
					'placeholder'   => __('YYYYMMDD'),
					), $checkout->get_value( 'PickupDate' ));			
			}
		echo '</div>';

		/*
			$oWC_Order_Custom->setaddress_AddressLine( $_POST['']);
			$oWC_Order_Custom->setCloseTime( $_POST['CloseTime']);
			$oWC_Order_Custom->setReadyTime( $_POST['ReadyTime']);
			$oWC_Order_Custom->setPickupDate( $_POST['PickupDate']);
			$oWC_Order_Custom->setCompanyName( $_POST['']);
			$oWC_Order_Custom->setContactName( $_POST['']);
			$oWC_Order_Custom->setSpecialInstruction( $_POST['']);
			*/
		
			
	}
}