<?php

if ( ! defined( 'ABSPATH' ) )
    exit;

function gootracking_getHtmlPdf($order_id) {
    
    $order = new WC_Order($order_id);   
    $oWC_Order_Custom = gootracking_WC_Order_Custom::getCorrectInstanceOf_WC_Order_Custom($order_id);
    
    




    /*
    $arrayoWC_Order_Custom =  $oWC_Order_Custom->getarrayoWC_Order_Custom(true);

    
//var_dump($arrayoWC_Order_Custom );

    $customer_user = $order->get_user_id( );
    $urlSternLogo = gootracking_getURLGooTrackingLogo();
    $urlSiteLogo = get_option('gootracking_logo_URL');
    if($urlSiteLogo=="") {
        $urlSiteLogo = $urlSternLogo;
    }
    
    $data = ""; 


    $data .= "<a href='".get_bloginfo( 'url' )."' target='_blank'><img src='". $urlSiteLogo  ."' alt='". get_bloginfo( 'title' ) ."' /></a>";
    
    $oQrCode = new gootracking_qrCode();
    $oQrCode->order_id = $order_id;
    $oQrCode->size = 200; 
    $data .= $oQrCode->get_shortcode();

    //$data .= gootracking_getURL_QRCode($order_id);
    $data .= "<p>";
    $data .= __('Hi. Thanks for using our service! Please add this label inside your item', 'gootracking-for-woocommerce' );
    $data .= "</p>";

    foreach ($arrayoWC_Order_Custom as $key => $value){
        $data .= "<p>".$key.": ".$value."</p>";     
    }
    //$items = $order->get_items();
    $line_items          = $order->get_items( apply_filters( 'woocommerce_admin_order_item_types', 'line_item' ) );
    //var_dump($items );
    //foreach ( $items as $item ) {
    foreach ( $line_items as $item_id => $item ) {
        //$data .= "<p>Name : ".$item['name']."</p>";
        //$data .= "<p>product_id : ".$item['product_id']."</p>";
        $_product  = $order->get_product_from_item( $item );
        //var_dump($_product->variation_data );
        //$_product = new WC_Product_Variation( $item['variation_id'] );
        //$variation_data = $_product->get_variation_attributes();
        //$variation_detail = woocommerce_get_formatted_variation( $variation_data, true );
        $data .= "<p>" . __('Details product:', 'gootracking').wc_get_formatted_variation( $_product->variation_data, true )."</p>";
    }
    //throw new Exception( '<strong>' .  __('Error Pick Up Client UPS', 'gootracking' )  . '</strong> '  . "bbb");
    $data .= "<p>".__('Phone:', 'gootracking'). " " . $order->billing_phone ."</p>";
    $data .= "<p>".__('Email:', 'gootracking'). " " . $order->billing_email ."</p>";
    $data .= "<p>".__('Total:', 'gootracking'). " " . $order->get_formatted_order_total() ."</p>";
    
    $data .= "<br>";    
    $data .= "<a href='http://gootracking.gooplus.fr/' target='_blank'><img src=". $urlSternLogo  ." alt=". get_bloginfo( 'title' ) ." /></a><br>";
    $data .= "<a href='http://gootracking.gooplus.fr/' target='_blank'>Gootracking.gooplus.fr</a>";
    //echo $data;
*/




    // --------------------------------------------------------------------------


    $detailsProduct='';
    $line_items          = $order->get_items( apply_filters( 'woocommerce_admin_order_item_types', 'line_item' ) );
    foreach ( $line_items as $item_id => $item ) {
        $_product  = $order->get_product_from_item( $item );
        $detailsProduct =wc_get_formatted_variation( $_product->variation_data, true );
    }

    $oQrCode = new gootracking_qrCode();
    $oQrCode->order_id = $order_id;
    $oQrCode->size = 200; 
    $qrCodeHTML = $oQrCode->get_shortcode();

    $labelIDText = __('Label ID', 'gootracking-for-woocommerce' );
    $userIdText = __('User ID', 'gootracking-for-woocommerce' );
    $quantityText = __('Quantity', 'gootracking-for-woocommerce' );
    $insideText = __('This label must be placed inside your item', 'gootracking-for-woocommerce' );
    $trackText = __('You can track your item and communicate thanks to your account in my orders', 'gootracking-for-woocommerce' );
    $serialText = __('Serial Number', 'gootracking-for-woocommerce' );
    $commentText = __('Comment', 'gootracking-for-woocommerce' );
    $titleText = __('Label Gootracking', 'gootracking-for-woocommerce' );


    $order_date = $order->order_date;
    //$URLGooTrackingLogoFormated = gootracking_option::getURLGooTrackingLogoFormated('100', false, false, true);

    $urlSiteLogo = get_option('gootracking_logo_URL');
    if($urlSiteLogo=="") {
        $imgSiteLogo = gootracking_option::getURLGooTrackingLogoFormated('100', false, false, true, true, true);
    } else {
        $imgSiteLogo = "<a href='".get_bloginfo( 'url' )."' target='_blank'><img src='". $urlSiteLogo  ."' alt='". get_bloginfo( 'title' ) ."' /></a>";
    }


    $data = '

<!DOCTYPE html>
<html>
<head>
    <title>'.$titleText.'</title>
    <style>
        *
        {
            margin:0;
            padding:0;
            font-family:Arial;
            font-size:10pt;
            color:#000;
        }
        body
        {
            width:100%;
            font-family:Arial;
            font-size:10pt;
            margin:0;
            padding:0;
        }
         
        p
        {
            margin:0;
            padding:0;
        }
         
        #wrapper
        {
            width:180mm;
            margin:0 15mm;
        }
         
        .page
        {
            height:297mm;
            width:210mm;
            page-break-after:always;
        }
 
        table
        {
            border-left: 1px solid #ccc;
            border-top: 1px solid #ccc;
             
            border-spacing:0;
            border-collapse: collapse; 
             
        }
         
        table td 
        {
            border-right: 1px solid #ccc;
            border-bottom: 1px solid #ccc;
            padding: 2mm;
        }
         
        table.heading
        {
            height:50mm;
        }
         
        h1.heading
        {
            font-size:14pt;
            color:#000;
            font-weight:normal;
        }
         
        h2.heading
        {
            font-size:9pt;
            color:#000;
            font-weight:normal;
        }
         
        hr
        {
            color:#ccc;
            background:#ccc;
        }
         
        #invoice_body
        {
            height: 149mm;
        }
         
        #invoice_body , #invoice_total
        {   
            width:100%;
        }
        #invoice_body table , #invoice_total table
        {
            width:100%;
            border-left: 1px solid #ccc;
            border-top: 1px solid #ccc;
     
            border-spacing:0;
            border-collapse: collapse; 
             
            margin-top:5mm;
        }
         
        #invoice_body table td , #invoice_total table td
        {
            text-align:center;
            font-size:9pt;
            border-right: 1px solid #ccc;
            border-bottom: 1px solid #ccc;
            padding:2mm 0;
        }
         
        #invoice_body table td.mono  , #invoice_total table td.mono
        {
            font-family:monospace;
            text-align:right;
            padding-right:3mm;
            font-size:10pt;
        }
         
        #footer
        {   
            width:180mm;
            margin:0 15mm;
            padding-bottom:3mm;
        }
        #footer table
        {
            width:100%;
            border-left: 1px solid #ccc;
            border-top: 1px solid #ccc;
             
            background:#eee;
             
            border-spacing:0;
            border-collapse: collapse; 
        }
        #footer table td
        {
            width:25%;
            text-align:center;
            font-size:9pt;
            border-right: 1px solid #ccc;
            border-bottom: 1px solid #ccc;
        }
    </style>
</head>
<body>
<div id="wrapper">
     
   
   
    <table class="heading" style="width:100%;">
        <tr>
            <td style="width:80mm;">
                '. $qrCodeHTML .'
            </td>
            <td rowspan="2" valign="top" align="right" style="padding:3mm;">
                '.$imgSiteLogo.'
                <br><br><br>
                <table>
                    <tr><td>'. $labelIDText .'</td><td>'.$order_id.'</td></tr>
                    <tr><td>'. $userIdText .'</td><td>'.$order->get_user_id().'</td></tr>
                    <tr><td>Date</td><td>'.$order_date.'</td></tr>
                </table>
                
                
            </td>
        </tr>
        <tr>
            <td>
                

                '.$order->get_formatted_shipping_address().'
                <br>
                '. $order->billing_phone .'
                <br>
                '. $order->billing_email .'


            </td>
        </tr>
    </table>
         
         
    <div id="content">
         
        <div id="invoice_body">
            <table>
            <tr style="background:#eee;">
                <td style="width:8%;"><b>ID</b></td>
                <td><b>Type</b></td>
                <td style="width:15%;"><b>Quantity</b></td>
                <td style="width:15%;"><b>Rate</b></td>
                <td style="width:15%;"><b>Total</b></td>
            </tr>
            </table>
             
            <table>
            <tr>
                <td style="width:8%;">1</td>
                <td style="text-align:left; padding-left:10px;">
                '.$oWC_Order_Custom->getshippingTypeFormated()   .'
                <br>
                '.$detailsProduct.'
                </td>
                <td class="mono" style="width:15%;">1</td><td style="width:15%;" class="mono">'.$order->get_formatted_order_total().'</td>
                <td style="width:15%;" class="mono">'.$order->get_formatted_order_total().'</td>
            </tr>         
            <tr>
                <td colspan="3"></td>
                <td></td>
                <td></td>
            </tr>
             
            <tr>
                <td colspan="3"></td>
                <td>Total :</td>
                <td class="mono">'.$order->get_formatted_order_total().'</td>
            </tr>
        </table>
        <br><br><br><br>
        <p>
        '.$insideText.'
        </p>
        <p>
        '.$trackText.'
        </p>
        <br><br><br>


            <table>
                <tr>
                    <td style="text-align:left; padding-left:10px;">
                        <p><b>'.$serialText.'</b> : '.$oWC_Order_Custom->getserialNumber().'</p>
                        <p><b>'.$commentText.'</b> : '.$oWC_Order_Custom->getcomment().'</p>
                    </td>

                </tr>
            </table>
       
        </div>

        <div id="invoice_total">
            
            <table>
                <tr>

                    <td style="text-align:left; padding-left:10px;">'. gootracking_option::getURLGooTrackingLogoFormated(false, true, false, false, false) .'</td>

                    <td style="width:35%;" class="mono">'. gootracking_option::getURLGooTrackingLogoFormated('70', false, false, true, true) .'</td>
                </tr>
            </table>
        </div>
   
         

    </div>
     
    <br />
     
    </div>
 
</body>
</html>
    ';



    
    return $data;
}